#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <xspawn.h>
#include "xmem.h"
#include "xpfv.h"
#include "vio.h"
#include "dirwin.h"

#define extern
#include "conf.h"
#undef extern


#ifdef SETUP
int	Ovr_comspec = 0,
	Ovr_home = 0;
#endif


struct conf {
	void	*value;
	int	type;
	char	*name;
	int	idflt;
	char	*sdflt;
};


struct conf Conf[] = {
{ &C_dir_frame_c,	'i',	"dir-frame-color",	0x1f,	NULL	},
{ &C_dir_text_c,	'i',	"dir-text-color",	0x1f,	NULL	},
{ &C_dir_bar_c,		'i',	"dir-bar-color",	0x3f,	NULL	},
{ &C_dir_tag_c,		'i',	"dir-tag-color",	0x71,	NULL	},
{ &C_dir_tagbar_c,	'i',	"dir-tagged-bar-color",	0x31,	NULL	},
{ &C_dir_fmt,		's',	"dir-format",		0, " a  s x n "},
{ &C_dir_left,		'i',	"dir-left-col",		-1,	NULL	},
{ &C_dir_top,		'i',	"dir-top-row",		0,	NULL	},
{ &C_dir_len,		'i',	"dir-length",		10,	NULL	},
{ &C_dir_tag_sym,	'i',	"dir-tag-symbol",	177,	NULL	},
{ &C_dir_notag_sym,	'i',	"dir-notag-symbol",	179,	NULL	},

{ &C_dest_fmt,		's',	"dest-format",		0, " a  s x n "},
{ &C_dest_left,		'i',	"dest-left-col",	0,	NULL	},
{ &C_dest_top,		'i',	"dest-top-row",		0,	NULL	},
{ &C_dest_len,		'i',	"dest-length",		10,	NULL	},

{ &C_pmt_frame_c,	'i',	"prompt-frame-color",	0x1b,	NULL	},
{ &C_pmt_text_c,	'i',	"prompt-text-color",	0x1f,	NULL	},
{ &C_pmt_high_c,	'i',	"prompt-high-color",	0x71,	NULL	},

{ &C_mnu_frame_c,	'i',	"menu-frame-color",	0x31,	NULL	},
{ &C_mnu_text_c,	'i',	"menu-text-color",	0x31,	NULL	},
{ &C_mnu_high_c,	'i',	"menu-high-color",	0x3f,	NULL	},
{ &C_mnu_bar_c,		'i',	"menu-bar-color",	0x4f,	NULL	},

{ &C_err_msg_c,		'i',	"error-msg-color",	0x4e,	NULL	},
{ &C_err_text_c,	'i',	"error-text-color",	0x4f,	NULL	},
{ &C_err_bar_c,		'i',	"error-bar-color",	0x70,	NULL	},

{ &C_cmd_text_c,	'i',	"command-text-color",	0x1f,	NULL	},
{ &C_cmd_frame_c,	'i',	"command-frame-color",	0x1b,	NULL	},

{ &C_browser_c,		'i',	"browser-color",	0x1f,	NULL	},
{ &C_bro_bold_c,	'i',	"browser-bold-attr",	0x1d,	NULL	},
{ &C_bro_uline_c,	'i',	"browser-underln-attr",	0x1b,	NULL	},

{ &C_inf_text_c,	'i',	"info-text-color",	0x6f,	NULL	},
{ &C_inf_high_c,	'i',	"info-high-color",	0x6b,	NULL	},

{ &C_winctl_c,		'i',	"window-ctl-color",	0x5f,	NULL	},
{ &C_path_c,		'i',	"path-color",		0x31,	NULL	},
{ &C_timer_c,		'i',	"timer-color",		0x71,	NULL	},

{ &C_tag_moves,		'i',	"tag-moves",		1,	NULL	},
{ &C_arrow_nav,		'i',	"arrows-navigate",	1,	NULL	},
{ &C_dot_tags,		'i',	"dot-key-tags",		0,	NULL	},
{ &C_show_dest,		'i',	"show-dest-win",	0,	NULL	},
{ &C_ins_mode,		'i',	"insert-mode",		1,	NULL	},
{ &C_conf_quit,		'i',	"confirm-quit",		1,	NULL	},
{ &C_dos_color,		'i',	"dos-color",		0x07,	NULL	},
{ &C_timeout,		'i',	"timeout",		600,	NULL	},
{ &C_zoom_mode,		'i',	"zoom-mode",		0,	NULL	},
{ &C_check_snow,	'i',	"check-snow",		0,	NULL	},
{ &C_browse_mode,	'i',	"browse-mode",		FV_TEXT,NULL	},
{ &C_sense_case,	'i',	"sense-case",		1,	NULL	},
{ &C_msg_time,		'i',	"message-timeout",	5,	NULL	},
{ &C_wildcard,		's',	"wildcard",		0,	"*.*"	},
{ &C_editor,		's',	"editor",		0, "~\\e.exe"	},
{ &C_fullpath,		'i',	"show-fullpath",	1,	NULL	},
{ &C_smallpath,		'i',	"show-smallpath",	1,	NULL	},
{ &C_comspec,		's',	"comspec",		0,	NULL	},
{ &C_sort_mtd,		'i',	"sort-method",		1,	NULL	},
{ &C_show_hidden,	'i',	"show-hidden-files",	1,	NULL	},
{ &C_show_timer,	'i',	"show-timer",		1,	NULL	},
{ &C_luser_mode,	'i',	"luser-mode",		1,	NULL	},

{ &C_home,		's',	"home",			0,	NULL	},

{ &C_swap,		'i',	"swapping-enabled",	1,	NULL	},
{ &C_swap_path,		's',	"swap-path",		0,	"C:\\"	},

{ NULL,			0,	NULL,			0,	NULL	},
};


struct action Dfl_actions[] = {
	{	"*.com",	"@exec %s"			},
	{	"*.exe",	"@exec %s"			},
	{	"*.bat",	"$COMSPEC /c %s"		},
	{	NULL,		NULL				}
};

static int	Na;

char *Dfl_fkeys[] = {
	"@view.ROFF ~/xphelp.xp5",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};


int strpos(char *s, int c) {
	int	i;

	if (islower(c)) c = toupper(c);
	for (i=0; s[i]; i++) if (s[i] == c) return(i);
	return(-1);
}


int xtoi(char *val, int *ok) {
	int	sign = 0;

	*ok = 1;

	if (*val == '-') {
		sign = 1;
		val++;
	}

	if (*val == '\'') {
		return(sign? -val[0]: val[1]);
	}
	else if (*val == '0') {
		int	v, i, p;
		int	radix = 10;
		char	*digits = "0123456789ABCDEF";

		val++;
		if (*val == 0) return(0);
		if (*val == 'x') {
			radix = 16; val++;
		}
		else {
			radix = 8;
		}
		p = digits[radix];
		digits[radix] = 0;
		v = 0;
		while ((i = strpos(digits, *val)) >= 0) {
			v = v*radix + i;
			val++;
		}
		digits[radix] = p;
		return(sign? -v: v);
	}
	else if (isdigit(*val)) {
		return(sign? -atoi(val): atoi(val));
	}
	else {
		*ok = 0;
		return(0);
	}
}


char *string(char *val) {
	if (!strcmp(val, "NULL")) return(NULL);
	if (*val == '"') {
		val[strlen(val)-1] = 0;
		return(xsave(val+1));
	}
	return(xsave(val));
}


void key_def(char *val) {
	char	*p, kx;

	kx = atoi(val);
	if ((p = strchr(val, ':')) == NULL) {
		printf("profile: bad key binding: %s\n", val);
		return;
	}
	F_keys[kx-1] = string(p+1);
}


void action_def(char *val) {
	char	*p;
	int	i;

	if ((p = strchr(val, ':')) == NULL) {
		printf("profile: bad action def: %s\n", val);
		return;
	}
	*p++ = 0;
	for (i=0; i<Na; i++) {
		if (!strcmp(Actions[i].pattern, val)) {
			xfree(Actions[i].pattern);
			xfree(Actions[i].action);
			Actions[i].pattern = xsave(val);
			Actions[i].action = string(p);
			return;
		}
	}
	if (Na >= MAX_ACTIONS-1) fatal("too many default actions");
	Actions[Na].pattern = xsave(val);
	Actions[Na++].action = string(p);
}


void setopt(char *opt, char *val) {
	int	i, f;

	if (!strcmp("key-def", opt)) {
		key_def(val); return;
	}
	if (!strcmp("action-def", opt)) {
		action_def(val); return;
	}
	for (i=0; Conf[i].name; i++) {
		if (!strcmp(Conf[i].name, opt)) {
			if ((!strcmp(Conf[i].name, "comspec") ||
		    	!strcmp(Conf[i].name, "home")) &&
		    	!strcmp(val, "NULL"))
		    		return;

#ifdef SETUP
			if (!strcmp(Conf[i].name, "comspec")) Ovr_comspec = 1;
			if (!strcmp(Conf[i].name, "home")) Ovr_home = 1;
#endif

			if (Conf[i].type == 'i') {
				*(int *) Conf[i].value = xtoi(val, &f);
				if (!f) printf(
				"profile: bad numeric value: %s\n", val);
			}
			else {
				*(char **) Conf[i].value = string(val);
			}
			return;
		}
	}
	printf("profile: bad option: %s\n", opt);
}


int loadconf() {
	char	path[PATHL], buf[129];
	FILE	*cf;
	char	*p, *v;

	sprintf(path, "%s/xpconf.xp5", C_home);
	if ((cf = fopen(path, "r")) == NULL) return(-1);

	fgets(buf, 128, cf);
	if (feof(cf)) {
		fclose(cf); return(-1);
	}
	if (strncmp(buf, "#XP5", 4)) {
		alert("Bad profile (magic match failed)", 0);
		fclose(cf); return(-1);
	}
	while (!feof(cf)) {
		buf[strlen(buf)-1] = 0;
		if (*buf == 0 || *buf == '#') goto next;
		if (!isalpha(*buf)) {
			printf("profile: bad syntax: %s\n", buf);
			goto next;
		}
		if ((p = strchr(buf, '=')) == NULL) {
			printf("profile: missing '=': %s\n", buf);
			goto next;
		}
		v = p+1;
		for (--p; *p == ' ' || *p == '\t'; p--)
			;
		p[1] = 0;
		for (; *v == ' ' || *v == '\t'; v++)
			;
		if (!(*v)) {
			printf("profile: missing value: %s\n", buf);
			goto next;
		}
		setopt(buf, v);
next:		fgets(buf, 128, cf);
	}

	fclose(cf);

	return(0);
}


void conf_vio() {
	vio_cksnow = C_check_snow;
	if (C_zoom_mode) {
		vio_clipx = 64;
		vio_lines = 18;
	}
	else {
		vio_clipx = 80;
		vio_lines = 25;
	}
}


int configure(char *home) {
	int	i, rc;
	char	*path;

	for (i=0; Conf[i].value; i++) {
		if (Conf[i].type == 'i') {
			*((int *) Conf[i].value) = Conf[i].idflt;
		}
		else if (Conf[i].type == 's') {
			*((char **) Conf[i].value) = Conf[i].sdflt;
		}
	}

	conf_vio();

	if (!C_home) {
		if ((path = getenv("XPHOME")) != NULL) home = path;
		C_home = xsave(home);
	}

	if (!C_comspec) {
		if ((C_comspec = getenv("COMSPEC")) == NULL)
			C_comspec = "C:\\command.com";
		C_comspec = xsave(C_comspec);
	}

#ifndef SETUP
	_swappath = C_swap_path;
#endif

	Actions = xmalloc(MAX_ACTIONS * sizeof(struct action));
	for (Na=0; Dfl_actions[Na].pattern; Na++) {
		if (Na >= MAX_ACTIONS-1) fatal("too many default actions");
		Actions[Na].pattern = xsave(Dfl_actions[Na].pattern);
		Actions[Na].action = xsave(Dfl_actions[Na].action);
	}

	memcpy(F_keys, Dfl_fkeys, sizeof(F_keys));

	rc = loadconf();

	conf_vio();

	Actions[Na].pattern = Actions[Na].action = NULL;
#ifndef SETUP
	Actions = xrealloc(Actions, ++Na * sizeof(struct action));
#endif

	loadhist();

	return(rc);
}


#ifndef SETUP

void clearconf() {
	int	i;

	for (i=0; Conf[i].value; i++) {
		if (Conf[i].type == 's' && *(char**)Conf[i].value) {
			free(*(char **)Conf[i].value);
		}
	}
	for (i=0; i<Na; i++) {
		if (Actions[i].pattern) free(Actions[i].pattern);
		if (Actions[i].action) free(Actions[i].action);
	}
	Na = 0;
	for (i=0; i<10; i++) {
		if (F_keys[i]) {
			free(F_keys[i]); F_keys[i] = NULL;
		}
	}
}


void reconfigure(char *home) {
	clearconf();
	configure(home);
}

#endif	/* !SETUP */


void shutdown() {
	savehist();
	if (C_luser_mode) printf("Winners never quit. Quitters never win.\n");
}


#ifdef SETUP
void saveconf() {
	char	path[PATHL];
	FILE	*cf;
	int	i;
	void	*val;

	sprintf(path, "%s/xpconf.xp5", C_home);
	if ((cf = fopen(path, "w")) == NULL) {
		alert("Cannot open config file", C_msg_time);
		return;
	}

	fprintf(cf, "#XP5");
	for (i=0; i<75; i++) fputc('#', cf);
	fprintf(cf, "\n#\n#\tDOS XPLORER 5.0 Profile\n#\n");
	for (i=0; i<79; i++) fputc('#', cf);
	fputc('\n', cf); fputc('\n', cf);

	for (i=0; Conf[i].name; i++) {
		fprintf(cf, "%s%s%s=\t", Conf[i].name,
		(strlen(Conf[i].name) < 16)? "\t": "",
		(strlen(Conf[i].name) < 8)? "\t": "");
		val = Conf[i].value;
		if ((!strcmp(Conf[i].name, "comspec") && !Ovr_comspec) ||
		(!strcmp(Conf[i].name, "home") && !Ovr_home)) {
			val = NULL;
		}
		if (Conf[i].type == 'i') {
			fprintf(cf, "%d\n", *(int *) val);
		}
		else {
			if (val)
				fprintf(cf, "\"%s\"\n", *(char **) val);
			else
				fprintf(cf, "NULL\n");
		}
	}
	fputc('\n', cf);

	for (i=0; i<10; i++) {
		fprintf(cf, "key-def\t\t=\t%d:%s%s%s\n",
		i+1,
		F_keys[i]? "\"": "",
		F_keys[i]? F_keys[i]: "NULL",
		F_keys[i]? "\"": "");
	}
	fputc('\n', cf);

	for (i=0; Actions[i].pattern; i++) {
		fprintf(cf, "action-def\t=\t%s:\"%s\"\n",
		Actions[i].pattern, Actions[i].action);
	}

	fputc('\n', cf);
	for (i=0; i<79; i++) fputc('#', cf);
	fputc('\n', cf);

	fclose(cf);
}
#endif	/* SETUP */


void show_timer() {
#ifndef SETUP
	extern struct dirwin	*Here;
	static time_t	st = 0;
	time_t	t;
	struct tm	*lt;
	char	buf[12];

	if (C_show_timer) {
		time(&t);
		if (t == st) goto skiptime;
		st = t;
		lt = localtime(&t);
		sprintf(buf, "%02d:%02d:%02d", lt->tm_hour, lt->tm_min,
		lt->tm_sec);
		vio_move(Here->x+Here->xl/2-4, Here->y+Here->yl);
		vio_color(C_timer_c);
		vio_puts(buf);
	}
skiptime:;
#endif	/* !SETUP */
}
