#include <stdio.h>
#include <dos.h>
#include <fcntl.h>
#include "keys.h"
#include "dirwin.h"
#include "vio.h"
#include "conf.h"


void fatal(char *msg) {
	vio_color(0x07); vio_clear();
	vio_color(0x4f);
	vio_win(5, 9, 74, 12);
	vio_color(0xcf);
	vio_move(27, 10); vio_puts("A FATAL ERROR HAS OCCURED");
	vio_color(0x4f);
	vio_move(39-strlen(msg)/2, 11);
	vio_puts(msg);
	vio_move(0, 15);
	vio_sync();
	exit(255);
}


void nomem() {
	fatal("Memory allocation failed");
}


void alert(char *msg, int timeout) {
	vio_color(C_err_msg_c);
	vio_alert(-1, -1, msg, timeout);
}


int exists(char *file, char *msg) {
	int	fd;

	if ((fd = open(file, O_RDONLY)) < 0) {
		alert(msg, C_msg_time);
		return(0);
	}
	close(fd);
	return(1);
}


void nyi() {
	alert("Not Yet Implemented", C_msg_time);
}



void fuckup(int eid, int dev_id, int dev_seg, int dev_off) {
	char	buf[1000], *msg;
	int	k, i, start, item, whatnow;
	int	x, y;

	x = vio_clipx/2 - 23;
	y = vio_lines/2 - 5;
	vio_save(x, y, x+47, y+8, buf);
	vio_color(C_err_msg_c);
	vio_win(x, y, x+47, y+8, buf);

	vio_move(x+5, y+2);
	vio_puts("Error condition on device  ");
	vio_color(C_err_text_c);
	if (dev_id > 0) {
		vio_putc((dev_id&0xff)+'A');
		vio_putc(':');
	}
	else {
		if (peek(dev_seg, dev_off+4) & 0x8000)
			start = dev_off+10;
		else
			start = dev_off+11;
		for (i=start; i<dev_off+18; i++) vio_putc(peekb(dev_seg, i));
	}

	switch(eid) {
		case 0:	msg = "Write protection violation"; break;
		case 1:	msg = "Unknown unit"; break;
		case 2:	msg = "Drive not ready"; break;
		case 3:	msg = "Unknown command"; break;
		case 4:	msg = "CRC error in data"; break;
		case 5:	msg = "Bad drive request block"; break;
		case 6:	msg = "Seek error"; break;
		case 7:	msg = "Unknown media type"; break;
		case 8:	msg = "Sector not found"; break;
		case 9:	msg = "Printer out of paper"; break;
		case 10:msg = "General write fault"; break;
		case 11:msg = "General read fault"; break;
		case 12:msg = "General failure"; break;
	}
	vio_move(x+5, y+4);
	vio_puts(msg);

	for (item=0;;) {
		vio_color(item==0? C_err_bar_c: C_err_text_c);
		vio_move(x+5, y+6);
		vio_puts("Retry");
		vio_color(item==1? C_err_bar_c: C_err_text_c);
		vio_move(x+21, y+6);
		vio_puts("Abort");
		vio_color(item==2? C_err_bar_c: C_err_text_c);
		vio_move(x+37, y+6);
		vio_puts("Ignore");
		k = vio_getc();
		if (k == 'a' || k == 'A') {
			whatnow = 1; break;
		}
		else if (k == 'i' || k == 'I') {
			whatnow = 2; break;
		}
		else if (k == 'r' || k == 'R') {
			whatnow = 0; break;
		}
		else if (k == K_LEFT) {
			if (--item < 0) item = 2;
		}
		else if (k == K_RGHT) {
			if (++item > 2) item = 0;
		}
		else if (k == K_CR) {
			whatnow = item; break;
		}
	}
	vio_rest(x, y, x+47, y+8, buf);
	switch(whatnow) {
		case 0:	hardresume(1);
		case 1:	hardretn(-1);
		case 2:	hardresume(0);
	}
}
