;;------------------------------------------------
;;
;;	FAST VIDEO Routines for DOS
;;	Copyright (C) 1995,1999 Nils M. Holm
;;	All rights reserved.
;;
;;------------------------------------------------


		.MODEL	LARGE


LINES		equ	25
COLS		equ	80


		.DATA

		PUBLIC	_vio_base, _vio_x, _vio_y, _vio_attr
		PUBLIC	_vio_lines, _vio_cols, _vio_clipx, _vio_cksnow

_vio_base	DW	?
_vio_x		DW	?
_vio_y		DW	?
_vio_attr	DW	?
_vio_lines	DW	LINES
_vio_clipx	DW	COLS
_vio_cols	DW	COLS
_vio_cksnow	DW	1


		.CODE

		PUBLIC	_vio_init, _vio_move, _vio_sync, _vio_color,
		PUBLIC	_vio_putc, _vio_puts, _vio_clear, _vio_clreol,
		PUBLIC	_vio_index, _vio_revind, _vio_getc, _vio_sync
		PUBLIC	_vio_mono, _vio_query, _vio_save, _vio_rest
		PUBLIC	_vio_getcx, _vio_getcy

SNOWCHECK macro
		LOCAL	wait4retrace, nocheck
		cmp	_vio_cksnow,0
		jz	nocheck
		push	ax
		push	dx
		mov	dx,03dah
wait4retrace:	in	al,dx
		test	al,1
		jz	wait4retrace
		pop	dx
		pop	ax
nocheck:
endm

vio_addr:
		mov	ax,_vio_y
		mov	cx,COLS*2
		mul	cx
		mov	di,_vio_x
		shl	di,1
		add	di,ax
		ret


PROC _vio_init
		push	bp
		push	si
		push	di
		xor	ax,ax
		mov	_vio_x,ax
		mov	_vio_y,ax
		mov	_vio_attr,0700h
		mov	ax,0f00h
		int	10h
		cmp	al,7
		jz	ismono
		mov	_vio_base,0b800h
		jmp	endinit
ismono:		mov	_vio_base,0b000h
endinit:	pop	di
		pop	si
		pop	bp
		ret
		ENDP

PROC _vio_mono
		mov	ax,0f00h
		int	10h
		cmp	al,2
		jz	mono
		cmp	al,7
		jz	mono
		xor	ax,ax
		ret
mono:		mov	ax,1
		ret
		ENDP


PROC _vio_move
		mov	bx,sp
		mov	ax,ss:[bx+4]
		mov	_vio_x,ax
		mov	ax,ss:[bx+6]
		mov	_vio_y,ax
		ret
		ENDP


PROC _vio_sync
		push	bp
		push	si
		push	di
		mov	ax,0200h
		xor	bx,bx
		mov	dx,_vio_x
		mov	cx,_vio_y
		xchg	cl,ch
		or	dx,cx
		int	10h
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_color
		mov	bx,sp
		mov	ax,ss:[bx+4]
		xchg	al,ah
		mov	_vio_attr,ax
		ret
		ENDP


PROC _vio_putc
		push	bp
		mov	bp,sp
		push	si
		push	di
		push	es
		mov	ax,_vio_base
		mov	es,ax
		call	vio_addr
		mov	ax,[bp+6]
		or	ax,_vio_attr
		SNOWCHECK
		mov	es:[di],ax
		inc	_vio_x
		pop	es
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_puts
		push	bp
		mov	bp,sp
		push	si
		push	di
		push	es
		push	ds
		mov	ax,_vio_base
		mov	es,ax
		call	vio_addr
		mov	si,[bp+6]
		mov	ax,_vio_attr
		mov	bx,[bp+8]
		mov	ds,bx
		cld
		mov	cx,si
		SNOWCHECK
nextps:		lodsb
		or	al,al
		jz	endps
		stosw
		jmp	nextps
endps:
		pop	ds
		sub	si,cx
		dec	si
		add	_vio_x,si
		pop	es
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_clear
		push	bp
		push	si
		push	di
		mov	ax,0600h
		xor	cx,cx
		mov	dx,184fh
		mov	bx,_vio_attr
		int	10h
		xor	ax,ax
		mov	_vio_x,ax
		mov	_vio_y,ax
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_clreol
		push	bp
		push	si
		push	di
		push	es
		mov	ax,_vio_base
		mov	es,ax
		call	vio_addr
		mov	ax,32
		or	ax,_vio_attr
		mov	cx,COLS
		sub	cx,_vio_x
		jz	endcl
		cld
		SNOWCHECK
doclr:		stosw
		loop	doclr
endcl:		pop	es
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_index
		push	bp
		mov	bp,sp
		push	si
		push	di
		mov	cx,[bp+6]
		mov	ax,[bp+8]
		or	ch,al
		mov	dx,[bp+10]
		mov	ax,[bp+12]
		or	dh,al
		mov	ax,0601h
		mov	bx,_vio_attr
		int	10h
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_revind
		push	bp
		mov	bp,sp
		push	si
		push	di
		mov	cx,[bp+6]
		mov	ax,[bp+8]
		or	ch,al
		mov	dx,[bp+10]
		mov	ax,[bp+12]
		or	dh,al
		mov	ax,0701h
		mov	bx,_vio_attr
		int	10h
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_getcx
		mov	ax,0300h
		int	10h
		mov	ax,dx
		xor	ah,ah
		ret
		ENDP


PROC _vio_getcy
		mov	ax,0300h
		int	10h
		mov	al,dh
		xor	ah,ah
		ret
		ENDP


PROC _vio_getc
		push	bp
		push	si
		push	di
		xor	ax,ax
		int	16h
		or	al,al
		jz	isext
		xor	ah,ah
		jmp	retch
isext:		xchg	al,ah
		or	ax,100h
retch:		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_query
		mov	ax,0100h
		int	16h
		jz	none
		xor	ax,ax
		dec	ax
		ret
none:		xor	ax,ax
		ret
		ENDP


PROC _vio_save
		push	bp
		mov	bp,sp
		push	si
		push	di
		push	es
		push	ds
		sub	sp,2

		mov	ax,_vio_cols
		mov	[bp-10],ax
		mov	ax,[bp+16]
		mov	es,ax
		mov	di,[bp+14]

		mov	ax,_vio_base
		mov	ds,ax

		mov	si,[bp+8]
		mov	ax,[bp-10]
		shl	ax,1
		mul	si
		mov	si,ax
		mov	ax,[bp+6]
		shl	ax,1
		add	si,ax

		mov	ax,[bp+10]
		sub	ax,[bp+6]
		inc	ax
		shl	ax,1
		mov	dx,ax

		SNOWCHECK

		cld
		mov	bx,si
getnrow:	mov	si,bx
		mov	cx,dx
		rep	movsb
		add	bx,[bp-10]
		add	bx,[bp-10]
		inc	word ptr [bp+8]
		mov	ax,[bp+8]
		cmp	ax,[bp+12]
		jbe	getnrow

		add	sp,2
		pop	ds
		pop	es
		pop	di
		pop	si
		pop	bp
		ret
		ENDP


PROC _vio_rest
		push	bp
		mov	bp,sp
		push	si
		push	di
		push	es
		push	ds
		sub	sp,2

		mov	ax,_vio_cols
		mov	[bp-10],ax

		mov	ax,_vio_base
		mov	es,ax

		mov	ax,[bp+16]
		mov	ds,ax
		mov	si,[bp+14]

		mov	di,[bp+8]
		mov	ax,[bp-10]
		shl	ax,1
		mul	di
		mov	di,ax
		mov	ax,[bp+6]
		shl	ax,1
		add	di,ax

		mov	ax,[bp+10]
		sub	ax,[bp+6]
		inc	ax
		shl	ax,1
		mov	dx,ax

		SNOWCHECK

		cld
		mov	bx,di
putnrow:	mov	di,bx
		mov	cx,dx
		rep	movsb
		add	bx,[bp-10]
		add	bx,[bp-10]
		inc	word ptr [bp+8]
		mov	ax,[bp+8]
		cmp	ax,[bp+12]
		jbe	putnrow

		add	sp,2
		pop	ds
		pop	es
		pop	di
		pop	si
		pop	bp
		ret
		ENDP

		END

