#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <dos.h>
#include <dir.h>
#include <ctype.h>
#include "vio.h"
#include "dirwin.h"
#include "xmem.h"
#include "keys.h"
#include "conf.h"


#define iswhite(c)	((c) == ' ')


char	Histbuf[MAXHIST][129];
int	Hrp, Hwp;


struct dirwin	*Cmd_ext = NULL;
int		Cmd_fcomp = 0;


void vio_frame(int x, int y, int dx, int dy) {
	int	i;

	vio_move(x, y); vio_putc(201);
	vio_move(dx, y); vio_putc(187);
	vio_move(x, dy); vio_putc(200);
	vio_move(dx, dy); vio_putc(188);
	for (i=x+1; i<dx; i++) {
		vio_move(i, y); vio_putc(205);
		vio_move(i, dy); vio_putc(205);
	}
	for (++y; y<dy; y++) {
		vio_move(x, y); vio_putc(186);
		vio_move(dx, y); vio_putc(186);
	}
}


void vio_box(int x, int y, int dx, int dy) {
	int	i;

	for (; y<=dy; y++) {
		vio_move(x, y);
		for (i=x; i<=dx; i++) vio_putc(' ');
	}
}


void vio_win(int x, int y, int dx, int dy) {
	vio_frame(x, y, dx, dy);
	vio_box(x+1, y+1, dx-1, dy-1);
}


struct viobuf *vio_protect(int x, int y, int dx, int dy) {
	struct viobuf	*vbuf;

	vbuf = (struct viobuf *) xmalloc(sizeof(struct viobuf));
	vbuf->vbuf = xmalloc(vio_size(x, y, dx, dy));
	vio_save(x, y, dx, dy, vbuf->vbuf);
	vbuf->x = x;
	vbuf->y = y;
	vbuf->dx = dx;
	vbuf->dy = dy;
	vbuf->cx = vio_getcx();
	vbuf->cy = vio_getcy();
	return(vbuf);
}


void vio_hide(struct viobuf *vb) {
	vio_rest(vb->x, vb->y, vb->dx, vb->dy, vb->vbuf);
	vio_move(vb->cx, vb->cy); vio_sync();
	xfree(vb->vbuf);
	xfree(vb);
}


static void _putitem(char *tx, int x, int y, int len, int tc, int hc, int hk) {
	int	i;

	vio_move(x, y);
	vio_color(tc);
	for (i=0; i<len; i++) vio_putc(' ');
	vio_move(x, y);
	for (i=0; tx[i]; i++) {
		if (tx[i] == '#') {
			if (hk) vio_color(hc);
			i++;
		}
		else {
			vio_color(tc);
		}
		vio_putc(tx[i]);
	}
}


int vio_menu(int x, int y, int txc, int barc, int hotc, int dfl, char *itemv) {
	static char	ilist[1000];
	char	*items[100];
	char	keys[100];
	char	*p, *q, *r;
	int	k, i, l, j, max = 0, len = 0;
	struct viobuf	*vbuf;

	strcpy(ilist, itemv);
	for (q=p=ilist; *p; ) {
		if (*p == '|') {
			*p = 0;
			l = strlen(q);
			if ((r = strchr(q, '#')) != NULL) {
				l--;
				keys[max] = *(r+1);
				if (islower(keys[max]))
					keys[max] = toupper(keys[max]);
			}
			len = (l>len)? l: len;
			items[max++] = q;
			q = ++p;
		}
		else {
			p++;
		}
	}
	l = strlen(q);
	if ((r = strchr(q, '#')) != NULL) {
		l--;
		keys[max] = *(r+1);
		if (islower(keys[max])) keys[max] = toupper(keys[max]);
	}
	items[max++] = q;
	len = (l>len)? l: len;

	if (x<0) x = (vio_clipx-1)/2-(len+3)/2;
	if (y<0) y = (vio_lines-1)/2-(max+1)/2;

	vbuf = vio_protect(x, y, x+len+3, y+max+1);

	vio_color(txc);
	vio_win(x, y, x+len+3, y+max+1);
	for (i=0; i<max; i++) {
		_putitem(items[i], x+2, y+i+1, len, txc, hotc, 1);
	}

	for (i=dfl;;) {
		_putitem(items[i], x+2, y+i+1, len, barc, hotc, 0);
		k = key();
		_putitem(items[i], x+2, y+i+1, len, txc, hotc, 1);
		switch (k) {
			case K_DOWN:	if (++i >= max) i=0; break;
			case K_UP:	if (--i < 0) i=max-1; break;
			case K_RGHT:	if (!C_arrow_nav) break;
			case K_CR:	vio_hide(vbuf); return(i);
			case K_LEFT:	if (!C_arrow_nav) break;
			case K_ESC:	vio_hide(vbuf); return(-1);
			default:	if (islower(k)) k = toupper(k);
					for (j=0; j<max; j++) {
						if (keys[j] == k) {
							vio_hide(vbuf);
							return(j);
						}
					}
		}
	}
}


void vio_alert(int x, int y, char *msg, int timeout) {
	int	l = strlen(msg);
	struct viobuf	*vb;

	if (x < 0) x = (vio_clipx-1)/2-(l+3)/2;
	if (y < 0) y = (vio_lines-1)/2-1;
	vb = vio_protect(x, y, x+l+3, y+2);
	vio_win(x, y, x+l+3, y+2);
	vio_move(x+2, y+1);
	vio_puts(msg);
	if (timeout)
		timed_key(timeout);
	else
		key();
	vio_hide(vb);
}


int fcomplete(char *buf, int pos, int blen) {
	struct ffblk	ff;
	char	path[PATHL], *p;
	char	prev[PATHL];
	int	nomatch, matches;
	int	max, i, j, len;
	int	oldpos = pos;
	int	mode;

	if (pos) pos--;
	while (!iswhite(buf[pos]) && pos) pos--;
	if (pos) pos++;
	strncpy(path, &buf[pos], PATHL);
	path[PATHL] = 0;

	if ((p = strchr(path, ' ')) != NULL) *p = 0;
	if (strchr(path, '.'))
		strcat(path, "*");
	else
		strcat(path, "*.*");

	matches = 0;
	nomatch = findfirst(path, &ff, 0x3f);
	max = NAMELEN;
	prev[0] = 0;
	while (!nomatch) {
		if (ff.ff_name[0] == '.') {
			nomatch = findnext(&ff);
			continue;
		}
		mode = ff.ff_attrib;
		matches++;
		lowcase(ff.ff_name);
		if (prev[0]) {
			for (i=0; i<max; i++)
				if (prev[i] != ff.ff_name[i])
					break;
			max = i;
		}
		strcpy(prev, ff.ff_name);
		nomatch = findnext(&ff);
	}

	if (!matches) {
		return(oldpos);
	}
	else {
		prev[max] = 0;
		if ((p = strrchr(path, '\\')) != NULL) *(p+1) = 0;
		else if ((p = strrchr(path, '/')) != NULL) *(p+1) = 0;
		else if ((p = strchr(path, ':')) != NULL) *(p+1) = 0;
		else path[0] = 0;
		strcat(path, prev);
		if (matches == 1) {
			if ((mode & FA_DIREC) == FA_DIREC)
				strcat(path, "\\");
			else
				strcat(path, " ");
		}

		if (strlen(buf) + strlen(path) >= blen) {
			return(oldpos);
		}

		while (buf[pos] != ' ' && buf[pos])
			for (i=pos; buf[i]; i++) buf[i] = buf[i+1];

		for (len=strlen(path), i=0; i<len; i++) {
			for (j=strlen(buf); j>=pos; j--) buf[j+1] = buf[j];
			buf[pos++] = path[i];
		}
	}

	return(pos);
}


int ffetch(struct dirwin *dw, char *buf, int cp, int len) {
	char	*file;
	int	i, j, lb;

	file = dw->dir->entries[dw->curr].name;
	if ((j = strlen(file)) + (lb = strlen(buf)) + 1 >= len) return(cp);
	for (i=lb; i>=cp; i--) buf[i+j+1] = buf[i];
	strncpy(buf+cp+1, file, j);
	*(buf+cp) = ' ';
	return(cp+j+1);
}


void showhist(char *line) {
	int	j;

	for (j=0; line[j] && j<46; j++) vio_putc(line[j]);
	while (j++<46) vio_putc(' ');
}


int history(char *buffer) {
	struct viobuf	*bg;
	int	i, k;
	int	x, y;

	x = (vio_clipx-1)/2 - 25;
	y = (vio_lines-1)/2 - MAXHIST/2;
	bg = vio_protect(x, y, x+49, y+MAXHIST+1);
	vio_color(C_mnu_frame_c);
	vio_frame(x, y, x+49, y+MAXHIST+1);
	vio_color(C_mnu_text_c);
	vio_box(x+1, y+1, x+48, y+MAXHIST);
	for (i=0; i<MAXHIST; i++) {
		vio_move(x+2, y+i+1); showhist(Histbuf[i]);
	}
	for (;;) {
		vio_move(x+2, y+Hrp+1);
		vio_color(C_mnu_bar_c);
		showhist(Histbuf[Hrp]);
		k = key();
		vio_move(x+2, y+Hrp+1);
		vio_color(C_mnu_text_c);
		showhist(Histbuf[Hrp]);
		i = K_CR;
		switch (k) {
			case K_LF:	i = K_LF;
			case K_CR:	strcpy(buffer, Histbuf[Hrp]);
			case K_ESC:	vio_hide(bg); return(i);
			case K_DOWN:	if (++Hrp >= MAXHIST) Hrp = 0; break;
			case K_UP:	if (--Hrp < 0) Hrp = MAXHIST-1; break;
		}
	}
}


void addtohist(char *buffer) {
	int	i;

	for (i=0; i<MAXHIST; i++) {
		if (!strcmp(Histbuf[i], buffer) && i != Hwp) {
			Hrp = i;
			return;
		}
	}
	strcpy(Histbuf[Hwp], buffer);
	Hrp = Hwp;
	if (++Hwp >= MAXHIST) Hwp = 0;
}


void loadhist() {
	char	buf[131];
	FILE	*hf;
	int	i;

	sprintf(buf, "%s/xphist.xp5", C_home);
	if ((hf = fopen(buf, "r")) == NULL) return;
	fgets(buf, 131, hf);
	if (!feof(hf)) {
		Hrp = atoi(buf);
		Hwp = atoi(buf+5);
		fgets(buf, 131, hf);
		for (i=0; i<MAXHIST && !feof(hf); i++) {
			buf[strlen(buf)-1] = 0;
			strcpy(Histbuf[i], buf);
			fgets(buf, 131, hf);
		}
	}
	fclose(hf);
}


void savehist() {
	char	path[PATHL];
	FILE	*hf;
	int	i;

	sprintf(path, "%s/xphist.xp5", C_home);
	if ((hf = fopen(path, "w")) == NULL) return;
	fprintf(hf, "%5d%5d\n", Hrp, Hwp);
	for (i=0; i<MAXHIST; i++) fprintf(hf, "%s\n", Histbuf[i]);
	fclose(hf);
}


int vio_prompt(int x, int y, int dx, int tc, int hc, int fc, int len, \
char *buf, char *title) {
	int	l;
	struct viobuf	*vb;
	int	cp, cl, co, max, k, red, i, dflt;

	l = dx<0? len+1: x<0? dx: dx-x;
	if (x < 0) {
		x = (vio_clipx-1)/2-l/2;
		if (x<0) x = 0;
	}
	dx = x+l;
	if (y < 0) {
		y = vio_lines/2-2;
	}
	l = dx-x+1;
	vb = vio_protect(x, y, x+l, y+2);
	vio_color(fc);
	vio_win(x, y, x+l, y+2);
	vio_move(x+2, y);
	vio_puts(title);

	dflt = *buf;
	max = dx-x;
	cl = cp = strlen(buf);
	if ((co = cl-max+1) < 0) co = 0;

	if (Cmd_ext) {
		dflt = 0;
		Cmd_fcomp = 1;
	}

	for (red = 1;;) {
		if (red) {
			vio_color((dflt)? hc: tc);
			vio_move(x+1, y+1);
			for (i=co; i<cl && i-co<max; i++)
				vio_putc(buf[i]);
			while (i++-co<max)
				vio_putc(' ');
			red = 0;
		}
		vio_move(x+1+cp-co, y+1); vio_sync();
		k = key();
		switch(k) {
			case K_HOME:	if (dflt) red = 1;
					dflt = 0;
					if (co) red = 1;
					cp = co = 0;
					break;
			case K_WLFT:	if (dflt) red = 1;
					dflt = 0;
					if (cp) --cp;
					while (iswhite(buf[cp]) && cp) cp--;
					while (!iswhite(buf[cp]) && cp) cp--;
					if (cp) ++cp;
					if (cp < co) {
						co = cp; red = 1;
					}
					break;
			case K_LEFT:	if (dflt) red = 1;
					dflt = 0;
					if (!cp) break;
					if (--cp < co) {
						co--; red = 1;
					}
					break;
			case K_RGHT:	if (dflt) red = 1;
					dflt = 0;
					if (cp>=cl) break;
					if (++cp-co >= max) {
						co++; red = 1;
					}
					break;
			case K_WRGT:	if (dflt) red = 1;
					dflt = 0;
					while (!iswhite(buf[cp]) && buf[cp])
						cp++;
					while (iswhite(buf[cp])) cp++;
					if (cp-co >= 77) {
						co = cp-77;
						red = 1;
					}
					break;
			case K_END:	if (dflt) red = 1;
					dflt = 0;
					cp = cl;
					if ((co = cl-max+1) < 0) co = 0;
					if (co) red = 1;
					break;
			case K_BKSP:	red = 1;
					dflt = 0;
					if (!cp) break;
					if (--cp < co) co--;
					/* FALLTHRU */
			case K_DEL:	red = 1;
					dflt = 0;
					if (cl <= cp) break;
					for (i=cp; i<cl; i++)
						buf[i] = buf[i+1];
					cl--;
					break;
			case ctl('U'):
			case K_KILL:	dflt = cl = cp = co = 0; red = 1;
					break;
			case K_INS:	if (dflt) red = 1;
					dflt = 0;
					C_ins_mode = !C_ins_mode; break;
			case K_DOWN:	if (!Cmd_ext) break;
					cp = ffetch(Cmd_ext, buf, cp, len);
					cl = strlen(buf);
					if (cp-co >= 77) co = cp-77;
					red = 1;
					break;
			case K_ESC:	vio_hide(vb);
					Cmd_ext = NULL;
					Cmd_fcomp = 0;
					return(-1);
			case K_UP:	if (!Cmd_ext) break;
					k = history(buf);
					cp = cl = strlen(buf);
					if (cp-co >= 77) co = cp-77;
					red = 1;
					if (k == K_LF) break;
			case K_CR:	if (Cmd_ext && cl > 3) addtohist(buf);
					vio_hide(vb);
					Cmd_ext = NULL;
					Cmd_fcomp = 0;
					return(cl);
			default:	if (k == K_TAB && Cmd_fcomp) {
						cp = fcomplete(buf, cp, len);
						cl = strlen(buf);
						if (cp-co >= 77) co = cp-77;
						red = 1;
						break;
					}
					if (k > 255) break;
					if (dflt) {
						cp = cl = co = 0;
						red = 1;
					}
					dflt = 0;
					if (cl>=len && (C_ins_mode || cp>=len))
						break;
					if (C_ins_mode)
						for (i=cl-1; i>=cp; i--)
						buf[i+1] = buf[i];
					buf[cp] = k;
					if (C_ins_mode)
						red = 1;
					else
						vio_putc(k);
					if (C_ins_mode || cp>=len) cl++;
					if (++cp-co >= max) {
						co++; red = 1;
					}
					buf[cl] = 0;
		}
	}
}
