#include <stdio.h>
#include <string.h>
#include "keys.h"
#include "vio.h"
#include "dirwin.h"
#include "conf.h"


struct dirwin	*Here;


void command(struct dirwin *this, struct dirwin *dw, struct dirwin *dest,
int k) {
	char	cmd[129];

	*cmd = k; cmd[1] = 0;
	Cmd_ext = this;
	if (vio_prompt(0, vio_lines-3, vio_clipx-2, C_cmd_text_c, C_cmd_text_c,
	C_cmd_frame_c, 128, cmd, "Command") < 0) return;
	if (!(*cmd)) return;
	expand(cmd, this);
	xp_execute(dw, dest, this, cmd);
}


int chdp(char *path) {
	int	origin;

	origin = getdisk();
	setdisk(*path-'A');
	if (chdir(path+2) < 0) {
		setdisk(origin);
		return(-1);
	}
	return(0);
}


int do_quit() {
	if (!C_conf_quit) return(1);
	return(menu(0, "  #Yes, quit| #No, continue ") == 0);
}


struct dirwin *makedest() {
	struct dirwin	*dest;
	char	path[PATHL+1];
	int	origin, i;

	getcwd(path, PATHL);
	Cmd_fcomp = 1;
	if ((vio_prompt(-1, -1, vio_clipx-10, C_pmt_text_c, C_pmt_high_c,
	C_pmt_frame_c, PATHL, path, "Destination Path")) < 0) return(NULL);
	if (path[i = strlen(path)-1] == '\\' && i > 3) path[i] = 0;
	if (path[1] == ':')  {
		*path = upcase(*path);
	}
	else {
		for (i=strlen(path); i>=0; i--) path[i+2] = path[i];
		path[1] = ':';
		path[0] = getdisk()+'A';

	}
	origin = getdisk();
	setdisk(*path-'A');
	if (path[2] && chdir(path+2)) {
		setdisk(origin);
		return(NULL);
	}
	getcwd(path, PATHL);
	dest = dw_open(C_dest_left, C_dest_top, C_dest_len, path, C_wildcard,
	C_dest_fmt, 0);
	return(dest);
}


void explore() {
	struct dirwin	*dw, *dest = NULL, *this;
	int	k;
	extern struct viobuf	*Pathbg;

	hplx_zoom(1);
	if (C_fullpath) Pathbg = vio_protect(0, vio_lines-1, 79,
		vio_lines-1);

	this = dw = dw_open(C_dir_left, C_dir_top, C_dir_len, NULL, C_wildcard,
	C_dir_fmt, 1);
	if (C_show_dest) {
		dest = dw_open(C_dest_left, C_dest_top, C_dest_len, NULL,
		C_wildcard, C_dest_fmt, 0);
		dw_bar(dest, 0);
	}

	Here = this;

	for (;;) {
		dw_bar(this, 1);
		if ((k = key()) == K_ESC) {
			if (do_quit()) break;
		}
		else if (k == K_TAB) {
			if (dest) {
				dw_refresh(this, 0);
				this = (this == dw)? dest: dw;
				dw_refresh(this, 1);
				chdp(this->dir->path);
			}
			else {
				dw_bar(this, 0);
				if ((dest = makedest()) != NULL) this = dest;
			}
		}
		else if (dw_move(this, k))
			;
		else if (dw_action(this, k))
			;
		else if (xp_command(&this, &dw, &dest, k))
			;
		else command(this, dw, dest, k);
	}

	dw_close(dw);
	if (dest) dw_close(dest);

	if (C_fullpath) vio_hide(Pathbg);
}


void inst_qcd(char *dir, int force) {
	char	buf[NAMELEN+1];

	if (!dir) {
		*buf = 0;
		if (vio_prompt(-1, -1, -1, C_pmt_text_c, C_pmt_high_c,
		C_pmt_frame_c, NAMELEN, buf, "QuickCD") < 0) return;
	}
	else {
		strcpy(buf, dir);
	}

	qcd(buf, force);
}


void inst_qff(char *file, int force) {
	char	buf[NAMELEN+5];

	if (!file) {
		*buf = 0;
		if (vio_prompt(-1, -1, -1, C_pmt_text_c, C_pmt_high_c,
		C_pmt_frame_c, NAMELEN, buf, "QuickFF") < 0) return;
	}
	else {
		strcpy(buf, file);
	}

	strcat(buf, strchr(buf, '.')? "*": "*.*");

	qff(buf, force);
}


int main(int argc, char **argv) {
	extern int	fuckup();
	char	*p;
	int	do_qcd = 0, do_qff = 0;

	if (argc > 1 && !strcmp(argv[1], "--qcd")) {
		do_qcd = 1;
	}
	else if (argc > 1 && !strcmp(argv[1], "--qff")) {
		do_qff = 1;
	}
	else {
		puts(
"-----  DOS XPLORER   Version 5.0A   Copyright (C) 1989-1999 Nils M Holm  -----"
		);
	}
	if ((p = strrchr(argv[0], '\\')) != NULL) *p = 0;
	vio_init();
	harderr(fuckup);
	configure(argv[0]);
	if (do_qcd) {
		if (!strcmp(argv[2], "-r"))
			inst_qcd(argv[3], 1);
		else
			inst_qcd(argv[2], 0);
		return(0);
	}
	else if (do_qff) {
		if (!strcmp(argv[2], "-r"))
			inst_qff(argv[3], 1);
		else
			inst_qff(argv[2], 0);
		return(0);
	}
	explore();
	shutdown();
	hplx_zoom(0);
	return(0);
}
