#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include "dirwin.h"
#include "vio.h"
#include "xpfv.h"
#include "conf.h"
#include "keys.h"

static char	b[MAXLINE];
static char	sr[MAXLINE];


void clrtobot() {
	vio_clreol();
	while (++vio_y < vio_lines-1) {
		vio_x = 0; vio_clreol();
	}
}


void show_text(f)
FILE	*f;
{
	int	c;

	vio_clreol();
	c = fgetc(f);
	while (!feof(f) && vio_y < vio_lines-1) {
		if (c == '\n' || vio_x >= vio_clipx) {
			vio_x = 0;
			vio_y++;
			if (vio_y < vio_lines-1) vio_clreol();
		}
		if (c == '\r') {
			vio_x = 0;
		}
		else if (c == '\t') {
			do {
				vio_putc(' ');
			} while (vio_x%8);
		}
		else if (c != '\n') {
			vio_putc(c);
		}
		c = fgetc(f);
	}
	ungetc(c, f);
	clrtobot();
}


void show_data(f)
FILE	*f;
{
	int	c, n = 0;

	c = fgetc(f);
	while (!feof(f) && n < (vio_lines-1)*vio_clipx) {
		vio_putc(c);
		if (vio_x >= vio_clipx) {
			vio_x = 0;
			vio_y++;
		}
		n++;
		c = fgetc(f);
	}
	ungetc(c, f);
	clrtobot();
}


void show_scr(f)
FILE	*f;
{
	int	c, n = 0, co = 0;

	c = fgetc(f);
	while (!feof(f) && n < FROWS*FCOLS) {
		vio_putc(c);
		n++; co++;
		if (n && !(n%FCOLS)) {
			while (co%vio_clipx) {
				vio_putc(' '); co++;
			}
			co = 0;
			vio_x = 0;
			vio_y++;
		}
		c = fgetc(f);
	}
	ungetc(c, f);
	clrtobot();
}


void show_dump(f)
FILE	*f;
{
	int	i, n = 0, r;
	unsigned char	b[16];
	char	h[9], *d = "0123456789ABCDEF";
	long	p;
	int	l;

	l = vio_clipx > 64;
	p = ftell(f);
	r = fread(b, 1, 16, f);
	while (r>0) {
		sprintf(h, l? "%08lx": "%05lx", p); vio_puts(h);
		vio_puts(l? ":  ": ": ");
		for (i=0; i<r; i++) {
			vio_putc(d[b[i]>>4]);
			vio_putc(d[b[i]&0xf]);
			if (l) {
				vio_putc(' ');
				if (i == 7) vio_putc(' ');
			}
			else {
				if ((i & 3) == 3) vio_putc(' ');
			}
		}
		vio_clreol();
		vio_x = l? 62: 44;
		for (i=0; i<r; i++) {
			vio_putc(b[i]);
			if (l) {
				if (i == 7) vio_putc(' ');
			}
			else {
				if ((i & 3) == 3) vio_putc(' ');
			}
		}
		vio_x = 0;
		vio_y++;
		p += 16;
		n++;
		if (n >= vio_lines-1) break;
		r = fread(b, 1, 16, f);
	}
	clrtobot();
}


void show_roff(f)
FILE	*f;
{
	int	c, c2 = 0;
	unsigned	a;

	vio_clreol();
	c = fgetc(f);
	while (!feof(f) && vio_y < vio_lines-1) {
		if (c == '\n' || vio_x >= vio_clipx) {
			vio_x = 0;
			vio_y++;
			if (vio_y < vio_lines-1) vio_clreol();
		}
		if (c == '\r') {
			vio_x = 0;
		}
		else if (c == '\t') {
			do {
				vio_putc(' ');
			} while (vio_x%8);
		}
		else if (c == '\b') {
			c = fgetc(f);
			a = vio_attr;
			if (c2 == '_' || c == '_') {
				vio_color(C_bro_uline_c);
				vio_x--;
				vio_putc(c=='_'? c2: c);
			}
			else {
				vio_color(C_bro_bold_c);
				vio_x--;
				vio_putc(c);
			}
			vio_color(a>>8);
		}
		else if (c != '\n') {
			vio_putc(c);
		}
		c2 = c;
		c = fgetc(f);
	}
	ungetc(c, f);
	clrtobot();
}


void down(f, top, mode)
FILE	*f;
long	top;
int	mode;
{
	long	here = top;

	fseek(f, here, SEEK_SET);
	switch(mode) {
		case FV_HEX:	fread(b, 1, 16, f); break;
		case FV_BINARY:	fread(b, 1, vio_clipx, f); break;
		case FV_SCR:	fread(b, 1, FCOLS, f); break;
		case FV_TEXT:
		case FV_NROFF:	fgets(b, MAXLINE, f); break;
	}
}


void up(f, top, mode)
FILE	*f;
long	top;
int	mode;
{
	long	here = top, fac;
	int	r, i, n;

	switch(mode) {
		case FV_HEX:	fac = (long) 16; break;
		case FV_BINARY:	fac = (long) vio_clipx; break;
		case FV_SCR:	fac = (long) FCOLS; break;
		case FV_TEXT:	fac = (long) MAXLINE; break;
		case FV_NROFF:	fac = (long) MAXLINE; break;
	}

	if ((here -= fac) < 0L) {
		fac += here;
		here = 0L;
	}

	fseek(f, here, SEEK_SET);
	if (mode == FV_TEXT || mode == FV_NROFF) {
		r = fread(b, 1, (unsigned) fac, f);
		for (n=0, i=r-1; i>0 && n < 2; i--)
			if (b[i] == '\n') n++;
		if (b[i+1] == '\n') i += 2;
		if (i<0) i = 0;
		fseek(f, here+i, SEEK_SET);
	}
}


void pgup(f, top, mode)
FILE	*f;
long	top;
int	mode;
{
	long	here = top, fac;
	static char	b[ROWS*(COLS+2)*2];
	int	r, i, x, y;

	switch(mode) {
		case FV_HEX:	fac = (long) (vio_lines-1)*16L; break;
		case FV_SCR:	fac = (long) FROWS*FCOLS; break;
		case FV_BINARY:	fac = (long) (vio_lines-1)*vio_clipx; break;
		case FV_TEXT:	fac = (long) (vio_lines-1)*(vio_clipx+2);
				break;
		case FV_NROFF:	fac = (long) (vio_lines-1)*(vio_clipx+2)*2;
				break;
	}

	if ((here -= fac) < 0L) {
		fac += here;
		here = 0L;
	}

	fseek(f, here, SEEK_SET);
	if (mode == FV_TEXT || mode == FV_NROFF) {
		r = fread(b, 1, (unsigned) fac, f);
		for (y=0, i=r; i>0 && y<vio_lines; i--) {
			if (b[i] == '\n') {
				x = 0;
				y++;
			}
			else if (b[i] == '\b' && mode == FV_NROFF) {
				if (--x < 0) x = 0;
			}
			else if (++x >= vio_clipx+2) {
				x = 0; y++;
			}
		}
		if (b[i+1] == '\n') i += 2;
		fseek(f, here+i, SEEK_SET);
	}
}


void end(f, mode)
FILE	*f;
int	mode;
{
	fseek(f, 0L, SEEK_END);
	pgup(f, ftell(f), mode);
	down(f, ftell(f), mode);
}


void statline(name, pos, size, mode)
char	*name;
long	pos, size;
int	mode;
{
	char	b[81];
	unsigned	a = vio_attr;
	int	p;

	vio_color(((a&0xf000)>>12) | ((a&0x700)>>4));
	if (vio_clipx > 64)
		sprintf(b,
		" %12s (%s) %10ld chars     F1=Help  M=mode  F=Find ",
			strchr(name, '/')? strrchr(name, '/')+1:
			strchr(name, '\\')? strrchr(name, '\\')+1: name,
			mode==FV_TEXT? "Text":
			mode==FV_BINARY? "Data":
			mode==FV_HEX? "Dump":
			mode==FV_NROFF? "Roff": "Scrn",
			size);
	else
		sprintf(b,
		" %12s (%s)       F1=Help  M=mode  F=Find ",
			strchr(name, '/')? strrchr(name, '/')+1:
			strchr(name, '\\')? strrchr(name, '\\')+1: name,
			mode==FV_TEXT? "Text":
			mode==FV_BINARY? "Data":
			mode==FV_HEX? "Dump":
			mode==FV_NROFF? "Roff": "Scrn");
	vio_move(0, vio_lines-1);
	vio_clreol();
	vio_puts(b);
	p = (int) (pos*100/size);
	if (p>100) p = 100;
	sprintf(b, "%3d%%", p);
	vio_move(vio_clipx-5, vio_lines-1);
	vio_puts(b);
	vio_color(a>>8);
}


void clrstat() {
	unsigned	a = vio_attr;

	vio_color(((a&0xf000)>>12) | ((a&0x700)>>4));
	vio_move(0, vio_lines-1);
	vio_clreol();
	vio_color(a>>8);
}


char *stristr(s1, s2)
char	*s1, *s2;
{
	int	l1, l2, i;

	l1 = strlen(s1);
	l2 = strlen(s2);
	for (i=0; i<l1-l2; i++)
		if (!strnicmp(&s1[i], s2, l2))
			return(&s1[i]);
	return(NULL);
}


void search(f, pos, mode, icase)
FILE	*f;
long	pos;
int	mode, icase;
{
	long	here = pos, top;
	int	len, a = vio_attr;
	char	*p, *q;
	char	title[41];

	sprintf(title, "Find text (case %s)", icase? "ignored": "sensed");
	if (vio_prompt(-1, -1, vio_clipx-16, C_pmt_text_c, C_pmt_high_c,
	C_pmt_frame_c, MAXLINE, sr, title) < 0) {
		vio_color(a>>8);
		fseek(f, here, SEEK_SET);
		return;
	}
	if (!(*sr)) {
		vio_color(a>>8);
		fseek(f, here, SEEK_SET);
		return;
	}

	fseek(f, pos, SEEK_SET);
	for (;;) {
		top = ftell(f);
		switch(mode) {
			case FV_NROFF:
			case FV_TEXT:	fgets(b, MAXLINE, f);
					len = strlen(b);
					if (feof(f)) len = 0;
					break;
			case FV_SCR:
			case FV_HEX:
			case FV_BINARY:	len = fread(b, 1, MAXLINE, f);
					break;
		}
		if (!len) {
			fseek(f, here, SEEK_SET);
			alert("No matches", C_msg_time);
			vio_color(a>>8);
			return;
		}
		if (mode == FV_NROFF) {
			for (p=q=b; *p; p++) {
				if (*p == '\b')
					q--;
				else
					*q++ = *p;
			}
		}

		if (icase) {
			if (stristr(b, sr)) {
				fseek(f, top, SEEK_SET);
				return;
			}
		} else {
			if (strstr(b, sr)) {
				fseek(f, top, SEEK_SET);
				return;
			}
		}
	}
}


void help() {
	unsigned	a = vio_attr;

	vio_color(((a&0xf000)>>12) | ((a&0x700)>>4));
	vio_move(0, 0); vio_puts(" File View  Version 1.2 ͻ");
	vio_move(0, 1); vio_puts("    (C) 1994,1999  Nils M Holm     ");
	vio_move(0, 2); vio_puts("͹");
	vio_move(0, 3); vio_puts(" PageDn/PageUp   Next/Prev. Page   ");
	vio_move(0, 4); vio_puts(" Up/Down Arrow   Scroll one line   ");
	vio_move(0, 5); vio_puts(" Home/End        Top/End of file   ");
	vio_move(0, 6); vio_puts("Ķ");
	vio_move(0, 7); vio_puts(" A/D/H/R/S       Select view mode: ");
	vio_move(0, 8); vio_puts("                 A-ASCII  D-Data   ");
	vio_move(0, 9); vio_puts("                 H-Hex    R-Runoff ");
	vio_move(0,10); vio_puts("                 S-4th Screens     ");
	vio_move(0,11); vio_puts(" M               Select next mode  ");
	vio_move(0,12); vio_puts("Ķ");
	vio_move(0,13); vio_puts(" F or /          Find string       ");
	vio_move(0,14); vio_puts(" C               Case sensitivity  ");
	vio_move(0,15); vio_puts("Ķ");
	vio_move(0,16); vio_puts(" ESC             Exit              ");
	vio_move(0,17); vio_puts("ͼ");
	vio_color(a>>8);
	key();
}


int setmode(int mode) {
	int	new, a = vio_attr;

	new = menu(mode,
	"Text (#ASCII)|Character #Dump|#Hex Dump|#ROFF Output|4TH #Screens");
	vio_color(a>>8);
	if (new<0) return(mode);
	return(new);
}


int setcase(int icase) {
	int	new, a = vio_attr;

	new = menu(icase, "#Sense case|#Ignore case");
	vio_color(a>>8);
	if (new<0) return(icase);
	return(new);
}


int upcase(c)
int	c;
{
	if (c>255) return(c);
	return (islower(c)? toupper(c): c);
}


int fv(name, mode, attr, icase)
char	*name;
int	*mode, *attr, *icase;
{
	struct viobuf	*bg;
	FILE	*f;
	void	(*show)();
	int	k;
	long	here, size;

	if ((f = fopen(name, "rb")) == NULL) return(-1);
	fseek(f, 0L, SEEK_END);
	size = ftell(f);
	rewind(f);

	bg = vio_protect(0, 0, 79, 24);

	vio_color(*attr);
	clrstat();

	for (;;) {
		here = ftell(f);
		vio_move(0, 0);
		switch(*mode) {
			case FV_TEXT:	show = show_text; break;
			case FV_BINARY:	show = show_data; break;
			case FV_HEX:	show = show_dump; break;
			case FV_NROFF:	show = show_roff; break;
			case FV_SCR:	show = show_scr; break;
		}
		vio_color(*attr);
		show(f);
		statline(name, ftell(f), size, *mode);

		switch (k = upcase(key())) {
			case K_LEFT:	if (!C_arrow_nav) break;
			case K_ESC:	goto finito;
			case K_DOWN:	down(f, here, *mode); break;
			case K_UP:	up(f, here, *mode); break;
			case K_PGDN:	if (feof(f))
						fseek(f, here, SEEK_SET);
					break;
			case K_PGUP:	pgup(f, here, *mode); break;
			case K_HOME:	rewind(f); break;
			case K_END:	end(f, *mode); break;
			case 'A': case 'D': case 'H': case 'R': case 'S':
					*mode =	(k=='A')? FV_TEXT:
						(k=='D')? FV_BINARY:
						(k=='H')? FV_HEX:
						(k=='R')? FV_NROFF:
						FV_SCR;
					fseek(f, here, SEEK_SET);
					break;
			case 'M':	*mode = setmode(*mode);
					fseek(f, here, SEEK_SET);
					break;
			case 'F':
			case '/':	search(f, here, *mode, *icase); break;
			case 'C':	*icase = setcase(*icase);
					fseek(f, here, SEEK_SET);
					break;
			case K_F1:
			case '?':	help();
			default:	fseek(f, here, SEEK_SET);
		}
	}

finito:
	fclose(f);
	vio_hide(bg);
	return(0);
}


void xpfv(char *name, int *modep) {
	int	icase = !C_sense_case;

	timerc(0);
	fv(name, modep, &C_browser_c, &icase);
	C_sense_case = !icase;
	timerc(1);
}
