#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include <dir.h>
#include "keys.h"
#include "vio.h"
#include "dirwin.h"
#include "util.h"
#include "conf.h"
#include "xpfv.h"
#include "xmem.h"


#define MAXHITS		200

struct dirrc {
	char	*name;
	int	depth;
};


extern char		Database[1];
extern struct dirrc	Dirs[1];
extern int		Ndir;

char	*Matches[MAXHITS];
int	Nhits;


char *mkmatch(char *path, char *file) {
	char	buf[PATHL];

	lowcase(file);
	if (strlen(path)+strlen(file) > 56) {
		sprintf(buf, "...%s%s", path+strlen(path)-56+strlen(file),
		file);
	}
	else {
		sprintf(buf, "%s%s", path, file);
	}
	return(xsave(buf));
}


int quickff(int x, int y, int dx, int dy, char *file) {
	int	i, nomore;
	char	path[PATHL];
	struct ffblk	fb;

	Nhits = 0;
	for (i=0; i<Ndir; i++) {
		sprintf(path, "%s/*.*", Dirs[i].name);
		nomore = findfirst(path, &fb, 0x3f);
		*(strchr(path, '*')) = 0;
		if (vio_query()) {
			if (vio_getc() == K_ESC) return(Nhits);
		}
		while (!nomore) {
			if (fnmatch(fb.ff_name, file)) {
				if (Nhits >= MAXHITS) {
					alert(
					"There are too many matching files",
					C_msg_time);
					return(Nhits);
				}
				Matches[Nhits++] = mkmatch(path, fb.ff_name);
				vio_color(C_dir_text_c);
				if (Nhits < dy-y-1) {
					vio_move(x+2, y+1+Nhits);
				}
				else {
					vio_index(x+1, y+1, dx-1, dy-1);
					vio_move(x+2, dy-1);
				}
				pth_puts(dx-x-3, Matches[Nhits-1]);
			}
			nomore = findnext(&fb);
		}
	}
	return(Nhits);
}


int qffbrowse(int x, int y, int dx, int dy) {
	int	k, i, j, red = 1;
	int	curr, top;
	int	lx, ly;

	lx = dx-x-4;
	ly = dy-y-1;
	timerc(0);
	curr = Nhits - 1;
	if ((top = curr-(ly-2)) < 0) top = 0;
	for (;;) {
		if (red) {
			vio_color(C_dir_text_c);
			for (i=0; i<ly && i+top < Nhits; i++) {
				vio_move(x+2, y+i+1);
				pth_puts(lx+1, Matches[i+top]);
				while (vio_x < dx-1) vio_putc(' ');
			}
			while (i<ly) {
				vio_move(x+1, y+i+++1);
				for (j=0; j<lx+2; j++) vio_putc(' ');
			}
			red = 0;
		}
		vio_color(C_dir_bar_c);
		vio_move(x+2, curr-top+y+1);
		pth_puts(lx+1, Matches[curr]);
		while (vio_x < dx-1) vio_putc(' ');
		k = key();
		vio_color(C_dir_text_c);
		vio_move(x+2, curr-top+y+1);
		pth_puts(lx+1, Matches[curr]);
		while (vio_x < dx-1) vio_putc(' ');
		switch (k) {
			case K_ESC:
				timerc(1); return(-1);

			case K_CR:
				timerc(1); return(curr);

			case K_DOWN:
				if (curr >= Nhits-1) break;
				if (++curr >= top+ly) {
					top++;
					vio_index(x+1, y+1, dx-1, dy-1);
					vio_move(x+2, curr-top+y+1);
					pth_puts(lx+1, Matches[curr]);
					while (vio_x < dx-1) vio_putc(' ');
				}
				break;

			case K_UP:
				if (curr < 1) break;
				if (--curr < top) {
					top--;
					vio_revind(x+1, y+1, dx-1, dy-1);
					vio_move(x+2, curr-top+y+1);
					pth_puts(lx+1, Matches[curr]);
					while (vio_x < dx-1) vio_putc(' ');
				}
				break;

			case K_PGDN:
				if ((curr += ly-1) >= Nhits) curr = Nhits-1;
				if ((top += ly-1) >= Nhits) {
					if ((top = curr-(ly-2)) < 0) top = 0;
				}
				red = 1;
				break;
			
			case K_PGUP:
				if ((curr -= ly-1) < 0) curr = 0;
				if ((top -= ly-1) < 0) top = 0;
				red = 1;
				break;

			case K_HOME:
				curr = top = 0; red = 1; break;
		
			case K_END:
				curr = Nhits - 1;
				if ((top = curr-(ly-2)) < 0) top = 0;
				red = 1;
				break;
		}
	}
}


char *qff(char *file, int force) {
	static char	name[16];
	struct viobuf	*bg;
	char	buf[60], *p;
	int	mx, n, i;
	int	x, y, dx, dy;

	x = 8;
	y = 4;
	dx = vio_clipx - 9;
	dy = vio_lines-5;

	if (force || readtree() < 0) {
		rescan();
		writetree();
	}

	bg = vio_protect(x, y, dx, dy);
	vio_color(C_dir_frame_c);
	vio_frame(x, y, dx, dy);
	vio_color(C_dir_text_c);
	vio_box(x+1, y+1, dx-1, dy-1);
	vio_color(C_inf_high_c);
	vio_move(x+3, y);
	sprintf(buf, "Quick File Find: \"%s\"", file);
	vio_puts(buf);
	mx = vio_x;

	quickff(x, y, dx, dy, file);
	deltree();
	if (!Nhits) {
		vio_hide(bg);
		alert("No matches", C_msg_time);
		return(NULL);
	}
	vio_move(mx, y);
	vio_color(C_inf_high_c);
	sprintf(buf, ": %d match%s", Nhits, (Nhits==1)? "": "es");
	vio_puts(buf);

	n = qffbrowse(x, y, dx, dy);

	if (n >= 0) {
		p = strrchr(Matches[n], '/');
		if (p[1]) *p = 0;
		chdir(Matches[n]);
		strcpy(name, p+1);
	}
	else {
		*name = 0;
	}

	for (i=0; i<Nhits; i++) xfree(Matches[i]);

	vio_hide(bg);
	return(*name? name: NULL);
}
