#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/timeb.h>
#include "keys.h"
#include "xmem.h"
#include "vio.h"
#include "dirwin.h"
#include "conf.h"


extern int	Ovr_comspec, Ovr_home;


char	Title[25][80] = {
"                                                                                ",
"                                                                                ",
"                                                                                ",
"                                              ",
"                                      ",
"                                                             ",
"                                                              ",
"                                                      ",
"                                                                 ",
"                                   ",
"                                                                   ",
"                                                  ",
"                                                     ",
"                                                         ",
"                                               ",
"                                                                             ",
"                                                                    ",
"                                                                   ",
"                                                          ",
"                                       ",
"                                         ",
"                                                                                ",
"                                                                                ",
"                                                                                ",
"       DOS XPLORER    Version 5.0A    Copyright (C) 1989-1999 Nils M Holm       "
};

int	ndxx[25][80], ndxy[25][80];


int dir_width(char *fmt) {
	int	len = 0;

	while (*fmt) {
		switch(*fmt) {
			case 'a': case 'A':	len += 4; break;
			case 'd': case 'D':	len += 8; break;
			case 'n': case 'N':	len += NAMELEN; break;
			case 's': case 'S':	len += 8; break;
			case 't': case 'T':	len += 5; break;
			case 'x': case 'X':	len ++; break;
			default:		len++;
		}
		fmt++;
	}

	return(len);
}


void putentry(char *fmt, int tag, int nc, int hc, int pos) {
	int	p = 0;

	while (*fmt) {
		vio_color(p++ == pos? hc: nc);
		switch(*fmt) {
			case 'a': case 'A':	vio_puts("Attr"); break;
			case 'd': case 'D':	vio_puts("__Date__"); break;
			case 'n': case 'N':	vio_puts("__FileName__");break;
			case 's': case 'S':	vio_puts("__Size__"); break;
			case 't': case 'T':	vio_puts("Time_"); break;
			case 'x': case 'X':	vio_putc(tag & 0xff); break;
			default:		vio_putc(*fmt & 0xff);
		}
		fmt++;
	}
}


void demo_screen(int full) {
	int	left, len, i, c;

	vio_color(C_dos_color); vio_clear();

	vio_color(C_dir_frame_c);
	len = dir_width(C_dir_fmt);
	if ((left = C_dir_left) == -1) left = 79-len-1;
	vio_frame(left, C_dir_top, left+len+1, C_dir_top+C_dir_len+1);

	vio_color(C_dir_text_c);
	vio_box(left+1, C_dir_top+1, left+len, C_dir_top+C_dir_len);

	for (i=0; i<C_dir_len; i++) {
		vio_move(left+1, i+C_dir_top+1);
		putentry(C_dir_fmt, C_dir_notag_sym, C_dir_text_c,
		C_dir_text_c, -1);
	}

	vio_move(left+1, C_dir_top+2);
	putentry(C_dir_fmt, C_dir_notag_sym, C_dir_bar_c, C_dir_bar_c, -1);
	vio_move(left+1, C_dir_top+3);
	putentry(C_dir_fmt, C_dir_tag_sym, C_dir_tag_c, C_dir_tag_c, -1);
	vio_move(left+1, C_dir_top+4);
	putentry(C_dir_fmt, C_dir_tag_sym, C_dir_tagbar_c, C_dir_tagbar_c, -1);

	if (full) {
		vio_color(C_winctl_c);
		len = dir_width(C_dest_fmt);
		if ((left = C_dest_left) == -1) left = 79-len-1;
		vio_frame(left, C_dest_top, left+len+1,
		C_dest_top+C_dest_len+1);
	}

	if (C_show_dest) {
		if (!full) {
			vio_color(C_dir_frame_c);
			len = dir_width(C_dest_fmt);
			if ((left = C_dest_left) == -1) left = 79-len-1;
			vio_frame(left, C_dest_top, left+len+1,
			C_dest_top+C_dest_len+1);
		}
		vio_color(C_dir_text_c);
		vio_box(left+1, C_dest_top+1, left+len, C_dest_top+C_dir_len);

		for (i=0; i<C_dest_len; i++) {
			vio_move(left+1, i+C_dest_top+1);
			putentry(C_dest_fmt, C_dir_notag_sym, C_dir_text_c,
			C_dir_text_c, -1);
		}
	}

	if (!full) return;

	vio_color(C_pmt_frame_c);
	vio_frame(20, 11, 59, 13);
	vio_move(23, 11);
	vio_puts("Prompt Box");
	vio_color(C_pmt_text_c);
	vio_box(21, 12, 58, 12);
	vio_move(22, 12);
	vio_puts("Normal Text ");
	vio_color(C_pmt_high_c);
	vio_puts("Highlighted Text");

	vio_color(C_mnu_frame_c);
	vio_frame(32, 1, 47, 5);
	vio_color(C_mnu_text_c);
	vio_box(33, 2, 46, 4);
	vio_move(34, 3); vio_puts("Menu Text...");
	vio_move(34, 4); vio_puts("More Text");
	vio_color(C_mnu_high_c);
	vio_move(39, 3); vio_putc('T');
	vio_move(34, 4); vio_putc('M');
	vio_color(C_mnu_bar_c);
	vio_move(34, 2); vio_puts("Menu Bar ...");

	vio_color(C_err_msg_c);
	vio_win(2, 10, 18, 14);
	vio_move(4, 11); vio_puts("Error Message");
	vio_color(C_err_text_c);
	vio_move(4, 12); vio_puts("Normal Text");
	vio_color(C_err_bar_c);
	vio_move(4, 13); vio_puts("Selected Text");

	vio_color(C_inf_text_c);
	vio_win(61, 10, 77, 14);
	vio_move(63, 11); vio_puts("Info Message");
	vio_color(C_inf_high_c);
	vio_move(63, 12); vio_puts("Highlighted");
	vio_move(63, 13); vio_puts(" Info Text");

	vio_color(C_cmd_frame_c);
	vio_win(0, 21, 79, 23);
	vio_move(3, 21); vio_puts("Command Prompt");
	vio_color(C_cmd_text_c);
	vio_move(2, 22); vio_puts("Command Prompt Text");

	vio_color(C_path_c);
	vio_move(0, 24); vio_clreol();
	vio_puts("Path Display");

	vio_color(C_browser_c);
	vio_move(28, 15); vio_puts("|Browser Normal Text ...|");
	vio_color(C_bro_uline_c);
	vio_move(28, 16); vio_puts("|Browser Underlined Text|");
	vio_color(C_bro_bold_c);
	vio_move(28, 17); vio_puts("|Browser Bold Text .....|");
	vio_color(C_browser_c);
	vio_move(28, 18); vio_puts("|Browser Normal Text ...|");
	c = (C_browser_c >> 4) | ((C_browser_c << 4) & 0x70);
	vio_color(c);
	vio_move(28, 19); vio_puts("|Browser Status Line ...|");
}


int setupmenu(int level, int dflt, char *itemv) {
	return (vio_menu(level*2, level, 0x70, 0x0e, 0x0e, dflt, itemv));
}


void setcolor(char *text, int *value) {
	int	x, y, k;

	vio_color(0x70);
	vio_win(2, 1, 37, 12);
	vio_move(4, 2); vio_puts(text);
	for (y=0; y<8; y++) {
		for (x=0; x<16; x++) {
			vio_move(4+x*2, 4+y);
			vio_color(x+y*16);
			vio_puts("**");
		}
	}
	y = *value / 16;
	x = *value % 16;
	for (;;) {
		vio_move(4+x*2, 4+y);
		vio_color(0x8e);
		vio_putc(219);
		k = key();
		vio_move(4+x*2, 4+y);
		vio_color(x+y*16);
		vio_puts("**");
		switch (k) {
			case K_ESC:	return;
			case K_CR:	*value = y*16+x; return;
			case K_UP:	if (--y < 0) y = 7; break;
			case K_DOWN:	if (++y > 7) y = 0; break;
			case K_LEFT:	if (--x < 0) x = 15; break;
			case K_RGHT:	if (++x > 15) x = 0; break;
		}
	}
}


void dirwin_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Frame color|"
				"#Text color|"
				"#Selection bar|"
				"T#ag color|"
				"Tagged #bar color");
		switch (slc) {
			case 0:		setcolor("Directory Frame",
					&C_dir_frame_c); break;
			case 1:		setcolor("Directory Text",
					&C_dir_text_c); break;
			case 2:		setcolor("Directory Selection Bar",
					&C_dir_bar_c); break;
			case 3:		setcolor("Directory Tagged Entry",
					&C_dir_tag_c); break;
			case 4:		setcolor("Directory Tagged Bar",
					&C_dir_tagbar_c); break;
			case 5:		return;
			default:	return;
		}
		dflt = slc;
	}
}


void prompt_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Frame color|"
				"#Normal text|"
				"#Highlighted text");
		switch (slc) {
			case 0:		setcolor("Prompt Box Frame",
					&C_pmt_frame_c); break;
			case 1:		setcolor("Prompt Normal Text",
					&C_pmt_text_c); break;
			case 2:		setcolor("Prompt Highlighted Text",
					&C_pmt_high_c); break;
			default:	return;
		}
		dflt = slc;
	}
}


void menu_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Frame color|"
				"#Text color|"
				"#Hotkey color|"
				"#Selection bar color");
		switch (slc) {
			case 0:		setcolor("Menu Frame",
					&C_mnu_frame_c); break;
			case 1:		setcolor("Menu Text",
					&C_mnu_text_c); break;
			case 2:		setcolor("Menu Hotkey",
					&C_mnu_high_c); break;
			case 3:		setcolor("Menu Selection Bar",
					&C_mnu_bar_c); break;
			default:	return;
		}
		dflt = slc;
	}
}


void message_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Message Text|"
				"#Unselected Text|"
				"#Selected Text");
		switch (slc) {
			case 0:		setcolor("Message Box Normal Text",
					&C_err_msg_c); break;
			case 1:		setcolor("Message Box Unselected Text",
					&C_err_text_c); break;
			case 2:		setcolor("Message Box Selected Text",
					&C_err_bar_c); break;
			default:	return;
		}
		dflt = slc;
	}
}


void info_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Normal Text|"
				"#Highlighted Text");
		switch (slc) {
			case 0:		setcolor("Info Box Normal Text",
					&C_inf_text_c); break;
			case 1:		setcolor("Info Box Highlighted Text",
					&C_inf_high_c); break;
			default:	return;
		}
		dflt = slc;
	}
}


void cmd_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Frame color|"
				"#Command text color");
		switch (slc) {
			case 0:		setcolor("Command Box Frame",
					&C_cmd_frame_c); break;
			case 1:		setcolor("Command Text",
					&C_cmd_text_c); break;
			default:	return;
		}
		dflt = slc;
	}
}


void browser_color() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Normal Text|"
				"#Underlined Text|"
				"#Bold Text");
		switch (slc) {
			case 0:		setcolor("Browser Normal Text",
					&C_browser_c); break;
			case 1:		setcolor("Browser Underlined Text",
					&C_bro_uline_c); break;
			case 2:		setcolor("Browser Bold Text",
					&C_bro_bold_c); break;
			default:	return;
		}
		dflt = slc;
	}
}


void other_colors() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Window Control Frame|"
				"#Path Display color|"
				"#Timer color|"
				"#DOS screen color");
		switch (slc) {
			case 0:		setcolor("Window Control Frame",
					&C_winctl_c); break;
			case 1:		setcolor("Path Display",
					&C_path_c); break;
			case 2:		setcolor("Timer",
					&C_timer_c); break;
			case 3:		setcolor("DOS screen",
					&C_dos_color); break;
			default:	return;
		}
		dflt = slc;
	}
}


void col_setup() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Directory window|"
				"#Prompt boxes|"
				"#Menu boxes|"
				"M#essage boxes|"
				"#Info boxes|"
				"#Command line|"
				"Text #browser|"
				"#Others");
		switch (slc) {
			case 0:		dirwin_color(); break;
			case 1:		prompt_color(); break;
			case 2:		menu_color(); break;
			case 3:		message_color(); break;
			case 4:		info_color(); break;
			case 5:		cmd_color(); break;
			case 6:		browser_color(); break;
			case 7:		other_colors(); break;
			default:	return;
		}
		dflt = slc;
	}
}


int	S_dir_frame_c,
	S_dir_text_c,
	S_dir_bar_c,
	S_dir_tag_c,
	S_dir_tagbar_c,
	S_pmt_frame_c,
	S_pmt_text_c,
	S_pmt_high_c,
	S_mnu_frame_c,
	S_mnu_text_c,
	S_mnu_high_c,
	S_mnu_bar_c,
	S_err_msg_c,
	S_err_text_c,
	S_err_bar_c,
	S_cmd_text_c,
	S_cmd_frame_c,
	S_browser_c,
	S_bro_bold_c,
	S_bro_uline_c,
	S_inf_text_c,
	S_inf_high_c,
	S_winctl_c,
	S_path_c,
	S_timer_c;


void save_colors() {
	S_dir_frame_c = C_dir_frame_c;
	S_dir_text_c = C_dir_text_c;
	S_dir_bar_c = C_dir_bar_c;
	S_dir_tag_c = C_dir_tag_c;
	S_dir_tagbar_c = C_dir_tagbar_c;
	S_pmt_frame_c = C_pmt_frame_c;
	S_pmt_text_c = C_pmt_text_c;
	S_pmt_high_c = C_pmt_high_c;
	S_mnu_frame_c = C_mnu_frame_c;
	S_mnu_text_c = C_mnu_text_c;
	S_mnu_high_c = C_mnu_high_c;
	S_mnu_bar_c = C_mnu_bar_c;
	S_err_msg_c = C_err_msg_c;
	S_err_text_c = C_err_text_c;
	S_err_bar_c = C_err_bar_c;
	S_cmd_text_c = C_cmd_text_c;
	S_cmd_frame_c = C_cmd_frame_c;
	S_browser_c = C_browser_c;
	S_bro_bold_c = C_bro_bold_c;
	S_bro_uline_c = C_bro_uline_c;
	S_inf_text_c = C_inf_text_c;
	S_inf_high_c = C_inf_high_c;
	S_winctl_c = C_winctl_c;
	S_path_c = C_path_c;
	S_timer_c = C_timer_c;
}


void rest_colors() {
	C_dir_frame_c = S_dir_frame_c;
	C_dir_text_c = S_dir_text_c;
	C_dir_bar_c = S_dir_bar_c;
	C_dir_tag_c = S_dir_tag_c;
	C_dir_tagbar_c = S_dir_tagbar_c;
	C_pmt_frame_c = S_pmt_frame_c;
	C_pmt_text_c = S_pmt_text_c;
	C_pmt_high_c = S_pmt_high_c;
	C_mnu_frame_c = S_mnu_frame_c;
	C_mnu_text_c = S_mnu_text_c;
	C_mnu_high_c = S_mnu_high_c;
	C_mnu_bar_c = S_mnu_bar_c;
	C_err_msg_c = S_err_msg_c;
	C_err_text_c = S_err_text_c;
	C_err_bar_c = S_err_bar_c;
	C_cmd_text_c = S_cmd_text_c;
	C_cmd_frame_c = S_cmd_frame_c;
	C_browser_c = S_browser_c;
	C_bro_bold_c = S_bro_bold_c;
	C_bro_uline_c = S_bro_uline_c;
	C_inf_text_c = S_inf_text_c;
	C_inf_high_c = S_inf_high_c;
	C_winctl_c = S_winctl_c;
	C_path_c = S_path_c;
	C_timer_c = S_timer_c;
}


void set_colors(set)
int	*set;
{
	C_dir_frame_c = set[0];
	C_dir_text_c = set[1];
	C_dir_bar_c = set[2];
	C_dir_tag_c = set[3];
	C_dir_tagbar_c = set[4];
	C_pmt_frame_c = set[5];
	C_pmt_text_c = set[6];
	C_pmt_high_c = set[7];
	C_mnu_frame_c = set[8];
	C_mnu_text_c = set[9];
	C_mnu_high_c = set[10];
	C_mnu_bar_c = set[11];
	C_err_msg_c = set[12];
	C_err_text_c = set[13];
	C_err_bar_c = set[14];
	C_cmd_text_c = set[15];
	C_cmd_frame_c = set[16];
	C_browser_c = set[17];
	C_bro_bold_c = set[18];
	C_bro_uline_c = set[19];
	C_inf_text_c = set[20];
	C_inf_high_c = set[21];
	C_winctl_c = set[22];
	C_path_c = set[23];
	C_timer_c = set[24];
}

/* DF    DT    DB    DG    DGB   PF    PT    PH    MF    MT    MH    MB    EM*/
/* ET    EB    CT    CF    BR    BB    BU    IT    IH    WI    PA    TI */
int	Colorsets[][25] = {
{ 0x1f, 0x1f, 0x3f, 0x71, 0x31, 0x1b, 0x1f, 0x71, 0x31, 0x31, 0x3f, 0x4f, 0x4e,
  0x4f, 0x70, 0x1f, 0x1b, 0x1f, 0x1d, 0x1b, 0x6f, 0x6b, 0x5f, 0x31, 0x71 },
{ 0x07, 0x07, 0x70, 0x07, 0x70, 0x07, 0x07, 0x70, 0x70, 0x70, 0x07, 0x07, 0x70,
  0x70, 0x07, 0x07, 0x07, 0x07, 0x70, 0x70, 0x07, 0x70, 0x70, 0x70, 0x70 },
{ 0x1b, 0x1b, 0x31, 0x1e, 0x3e, 0x31, 0x31, 0x3e, 0x3f, 0x3f, 0x3e, 0x0f, 0x4f,
  0x4f, 0x0f, 0x1b, 0x1b, 0x17, 0x1e, 0x1b, 0x71, 0x7e, 0x1e, 0x30, 0x31 },
};

void slc_colorset() {
	int	dflt = 0, slc;

	save_colors();
	for (;;) {
		demo_screen(1);
		slc = setupmenu(1, dflt,
				"#Default colors|"
				"#Monochrome colors|"
				"#NC-style colors|"
				"#Restore previous");
		switch (slc) {
			case 0:		set_colors(Colorsets[0]); break;
			case 1:		set_colors(Colorsets[1]); break;
			case 2:		set_colors(Colorsets[2]); break;
			case 3:		rest_colors(); break;
			default:	return;
		}
		dflt = slc;
	}
}


void win_move(int *left, int *top, int width, int len) {
	struct viobuf	*bg;
	int	k, x, y;

	x = (*left == -1)? 78-width: *left;
	y = *top;
	for (;;) {
		bg = vio_protect(x, y, x+width+1, y+len+1);
		vio_color(0x77);
		vio_frame(x, y, x+width+1, y+len+1);
		k = key();
		vio_hide(bg);
		switch (k) {
			case K_CR:	if (x == 78-width) x = -1;
					*left = x; *top = y;
					/* FALLTHRU */
			case K_ESC:	return;
			case K_UP:	if (y) --y; break;
			case K_LEFT:	if (x) --x; break;
			case K_DOWN:	if (y+len+1 < 24) ++y; break;
			case K_RGHT:	if (x+width+1 < 79) ++x; break;
			case K_HOME:	x = 0; break;
			case K_END:	x = 78-width; break;
			case K_PGUP:	y = 0; break;
			case K_PGDN:	y = 24-len-1; break;
		}
	}
}


void win_size(int *len, int left, int top, int width) {
	struct viobuf	*bg;
	int	k, l;

	l = *len;
	if (left == -1) left = 78-width;
	for (;;) {
		bg = vio_protect(left, top, left+width+1, top+l+1);
		vio_color(0x77);
		vio_frame(left, top, left+width+1, top+l+1);
		k = key();
		vio_hide(bg);
		switch (k) {
			case K_CR:	*len = l; /* FALLTHRU */
			case K_ESC:	return;
			case K_UP:	if (l > top+5) --l; break;
			case K_DOWN:	if (top+l < 23) ++l; break;
			case K_HOME:	l = top+5; break;
			case K_END:	l = 23-top; break;
		}
	}
}


int chartable(char *text, int dfl) {
	int	x, y, k, old;

	if (dfl < 0) dfl = 256+dfl;
	old = dfl;
	vio_color(0x70);
	vio_win(2, 1, 37, 12);
	vio_move(4, 2); vio_puts(text);
	for (y=0; y<8; y++) {
		for (x=0; x<32; x++) {
			vio_move(4+x, 4+y);
			vio_putc((y*32+x) & 0xff);
		}
	}
	y = dfl / 32;
	x = dfl % 32;
	for (;;) {
		vio_move(4+x, 4+y);
		vio_color(0x0e);
		vio_putc((y*32+x) & 0xff);
		k = key();
		vio_move(4+x, 4+y);
		vio_color(0x70);
		vio_putc((y*32+x) & 0xff);
		switch (k) {
			case K_ESC:	return(old);
			case K_CR:	return(y*32+x);
			case K_UP:	if (--y < 0) y = 7; break;
			case K_DOWN:	if (++y > 7) y = 0; break;
			case K_LEFT:	if (--x < 0) x = 31; break;
			case K_RGHT:	if (++x > 31) x = 0; break;
		}
	}
}


void win_layout(char **lp) {
	int	width, x, i, j, k, pos, clr = 1;
	static char	layout[40], buf[80];
	char	*m;

	strcpy(layout, *lp);

	width = dir_width(layout);
	x = 78-width;

	for (pos = 0;;) {
		if (clr) {
			width = dir_width(layout);
			x = 78-width;
			vio_color(C_dos_color);
			vio_clear();
			vio_color(C_dir_frame_c);
			vio_frame(x, 0, x+width+1, 12);
			vio_color(C_dir_text_c);
			vio_box(x+1, 1, x+width, 11);
			vio_color(0x70);
			vio_win(0, 0, 25, 7);
			vio_move(2, 1); vio_puts("<- -> = move bar");
			vio_move(2, 2); vio_puts("DEL   = remove field");
			vio_move(2, 3); vio_puts("INS   = add field");
			vio_move(2, 4); vio_puts("'X'   = set tag marker");
			vio_move(2, 5); vio_puts("ESC   = cancel");
			vio_move(2, 6); vio_puts("ENTER = change & exit");
			clr = 0;
		}
		vio_color(0x70);
		vio_win(20, 14, 59, 16);
		switch(layout[pos]) {
			case 'a': case 'A':
				m = "File attributes";
				break;
			case 'd': case 'D':
				m = "Date of last modification";
				break;
			case 'n': case 'N':
				m = "File name";
				break;
			case 's': case 'S':
				m = "File size in bytes";
				break;
			case 't': case 'T':
				m = "Time of last modification";
				break;
			case 'x': case 'X':
				sprintf(buf,
				"Tag marker (On = '%c', Off = '%c')",
				C_dir_tag_sym, C_dir_notag_sym);
				m = buf;
				break;
			default:
				sprintf(buf, "Character '%c'", layout[pos]);
				m = buf;
		}
		vio_move(39-strlen(m)/2, 15); vio_puts(m);
		for (i=0; i<11; i++) {
			vio_move(x+1, i+1);
			putentry(layout, i<3? C_dir_tag_sym: C_dir_notag_sym,
			C_dir_text_c, C_dir_bar_c, pos);
		}
		k = key();
		switch (k) {
			case K_CR:
				*lp = layout;
				/* FALLTHRU */

			case K_ESC:
				return;

			case K_DEL:
				j = strlen(layout);
				for (i=pos; i<j; i++)
					layout[i] = layout[i+1];
				clr = 1;
				break;

			case K_INS:
				i = setupmenu(2, 0,
						"File #Attributes|"
						"Modification #Date|"
						"File #Name|"
						"File #Size|"
						"Modification #Time|"
						"Tag #Marker|"
						"Vertical #Bar|"
						"D#ouble Bar|"
						"B#lank|"
						"Other #Character");
				if (i < 0) break;
				for (j=strlen(layout); j>=pos; j--)
					layout[j+1] = layout[j];
				switch (i) {
					case 0:	k = 'a'; break;
					case 1:	k = 'd'; break;
					case 2:	k = 'n'; break;
					case 3:	k = 's'; break;
					case 4:	k = 't'; break;
					case 5:	k = 'x'; break;
					case 6:	k = 179; break;
					case 7:	k = 186; break;
					case 8:	k = ' '; break;
					case 9:	k = chartable(
						"Select character", 179);
						break;
				}
				layout[pos] = k;
				clr = 1;
				break;

			case K_RGHT:
				if (!layout[++pos]) pos = 0; break;

			case K_LEFT:
				if (--pos < 0) pos = strlen(layout)-1; break;

			case 'x': case 'X':
				C_dir_tag_sym = chartable("Select Tag Symbol",
				C_dir_tag_sym);
				C_dir_notag_sym = chartable(
				"Select NoTag Symbol", C_dir_notag_sym);
				clr = 1;
				break;
		}
	}
}


void win_setup() {
	int	dflt = 0, slc;

	for (;;) {
		demo_screen(0);
		slc = setupmenu(1, dflt,
			"#Move Directory window|"
			"#Resize Directory window|"
			"Directory window #Layout|"
			"M#ove Destination window|"
			"R#esize Destination window|"
			"Destination window L#ayout");
		switch (slc) {
			case 0:		win_move(&C_dir_left, &C_dir_top,
					dir_width(C_dir_fmt), C_dir_len);
					break;
			case 1:		win_size(&C_dir_len, C_dir_left,
					C_dir_top, dir_width(C_dir_fmt));
					break;
			case 2:		win_layout(&C_dir_fmt);
					break;
			case 3:		win_move(&C_dest_left, &C_dest_top,
					dir_width(C_dest_fmt), C_dest_len);
					break;
			case 4:		win_size(&C_dest_len, C_dest_left,
					C_dest_top, dir_width(C_dest_fmt));
					break;
			case 5:		win_layout(&C_dest_fmt);
					break;
			default:	return;
		}
		dflt = slc;
	}
}


void setvalue(char *text, int llow, int lhigh, int *value) {
	char	nb[12];
	int	v, f;

	vio_color(0x70);
	vio_win(4, 2, 4+strlen(text)+5, 10);
	vio_move(7, 4); vio_puts(text);

	vio_move(7, 6); vio_puts("Lower Limit: ");
	vio_color(0x0e);
	sprintf(nb, "%5d", llow); vio_puts(nb);

	vio_color(0x70);
	vio_move(7, 8); vio_puts("Upper Limit: ");
	vio_color(0x0e);
	sprintf(nb, "%5d", lhigh); vio_puts(nb);

	sprintf(nb, "%d", *value);
	if (vio_prompt(-1, -1, -1, 0x70, 0x0e, 0x70, 10, nb, "") >= 0) {
		v = xtoi(nb, &f);
		if (f) *value = v;
	}

	vio_color(C_dos_color);
	vio_clear();
}


void setstring(char *text, char **value, int length) {
	char	buf[256];

	vio_color(0x70);
	vio_win(4, 2, 4+strlen(text)+5, 6);
	vio_move(7, 4); vio_puts(text);

	strcpy(buf, *value);

	if (vio_prompt(0, -1, vio_clipx-2, 0x70, 0x0e, 0x70, length,
	buf, "") >= 0) {
		*value = xsave(buf);
	}

	vio_color(C_dos_color);
	vio_clear();
}


void setstr2(char *text, char **value, int length, char *hint, int *ovr) {
	char	buf[256], j;

	vio_color(0x70);
	vio_win(4, 2, 4+strlen(text)+5, 6);
	vio_move(7, 4); vio_puts(text);

	vio_color(0x0f);
	vio_move(40, j=1);
	while (*hint) {
		if (*hint == '\n')
			vio_move(40, ++j);
		else
			vio_putc(*hint);
		hint++;
	}

	vio_move(4, 18);
	vio_puts("Current setting: ");
	vio_puts(*ovr? "OVERRIDE": "DEFAULT");

	strcpy(buf, *value);

	switch (vio_menu(4, 8, 0x70, 0x0e, 0x0e, *ovr,
	"Use #Default|#Override")) {
		case 0: *ovr = 0; break;
		case 1: if (vio_prompt(0, -1, vio_clipx-2, 0x70, 0x0e, 0x70,
			length, buf, "") >= 0) {
				*value = xsave(buf);
			}
			*ovr = 1;
			break;
	}

	vio_color(C_dos_color);
	vio_clear();
}


char *yesno(int b) {
	return(b? "YES": "NO");
}


char *onoff(int b) {
	return(b? "ON": "OFF");
}


void general_opts() {
	char	buf[1024];
	int	dflt = 0, slc, k;

	for (;;) {
		sprintf(buf,
			"Tagging a file moves the bar           : %s|"
			"Enable lynx-style arrow navigation     : %s|"
			"The dot key (.) tags a file            : %s|"
			"Quit must be confirmed                 : %s|"
			"Default input mode (prompt boxes)      : %s|"
			"|"
			"Open destination window on startup     : %s|"
			"Always display the current path        : %s|"
			"Display window titles (directory name) : %s|"
			"Directory sort method                  : %s|"
			"Display hidden/system files            : %s|"
			"Display system time                    : %s|"
			"|"
			"Default mode for file browser          : %s|"
			"Case-sensitivity in text searches      : %s|"
			"|"
			"Screen saver timeout (0 = off)         : %d min",
			yesno(C_tag_moves),
			yesno(C_arrow_nav),
			yesno(C_dot_tags),
			yesno(C_conf_quit),
			C_ins_mode? "INSERT": "REPLACE",
			yesno(C_show_dest),
			yesno(C_fullpath),
			yesno(C_smallpath),
			(C_sort_mtd == 0)? "DO NOT SORT":
			(C_sort_mtd == 1)? "SORT BY NAME":
			(C_sort_mtd == 2)? "SORT BY EXTENSION, THEN NAME":
			"***** BAD VALUE *****",
			yesno(C_show_hidden),
			yesno(C_show_timer),
			(C_browse_mode == 0)? "ASCII TEXT":
			(C_browse_mode == 1)? "CHARACTER DUMP":
			(C_browse_mode == 2)? "HEX DUMP":
			(C_browse_mode == 3)? "ROFF OUTPUT":
			(C_browse_mode == 4)? "FORTH SCREENS":
			"***** BAD VALUE *****",
			onoff(C_sense_case),
			C_timeout / 60);
		slc = setupmenu(2, dflt, buf);
		switch (slc) {
			case 0:		C_tag_moves = !C_tag_moves; break;
			case 1:		C_arrow_nav = !C_arrow_nav; break;
			case 2:		C_dot_tags = !C_dot_tags ; break;
			case 3:		C_conf_quit = !C_conf_quit; break;
			case 4:		C_ins_mode = !C_ins_mode; break;
			case 5:		break;
			case 6:		C_show_dest = !C_show_dest; break;
			case 7:		C_fullpath = !C_fullpath; break;
			case 8:		C_smallpath = !C_smallpath; break;
			case 9:		k = setupmenu(3, C_sort_mtd,
							"#Do not sort|"
							"Sort by #Name|"
							"Sort by #Extension");
					if (k >= 0) C_sort_mtd = k;
					break;
			case 10:	C_show_hidden = !C_show_hidden; break;
			case 11:	C_show_timer = !C_show_timer; break;
			case 12:	break;
			case 13:	k = setupmenu(3, C_browse_mode,
							"ASCII #Text|"
							"#Character Dump|"
							"#Hex Dump|"
							"#ROFF Output|"
							"#FORTH Screens");
					if (k >= 0) C_browse_mode = k;
					break;
			case 14:	C_sense_case = !C_sense_case; break;
			case 15:	break;
			case 16:	k = C_timeout / 60;
					setvalue("Screen Saver Timeout (mins)",
					0, 30, &k);
					C_timeout = k * 60;
					break;
			default:	return;
		}
		dflt = slc;
	}
}


void advanced_opts() {
	char	buf[1024];
	int	dflt = 0, slc;
	char	*h_comspec, *h_home;

	h_comspec = 
		"The path of the default command\n"
		"interpreter. Usually, this entry is\n"
		"taken from the variable COMSPEC at\n"
		"startup. When COMSPEC does not exist,\n"
		"C:\\COMMAND.COM is used as a last\n"
		"resort.\n"
		"Setting this option will override\n"
		"COMSPEC.\n"
		"RECOMMENDED SETTING: DEFAULT";
	h_home =
		"The directory where DOS XPLORER files\n"
		"reside. Normally, the value of the\n"
		"variable XPHOME is used. When XPHOME\n"
		"does not exist, the path of XP.EXE\n"
		"will be used.\n"
		"Setting this option will override\n"
		"XPHOME.\n"
		"RECOMMENDED SETTING: DEFAULT";
	for (;;) {
		sprintf(buf,
			"Timeout for #Error messages (0 = none)  : %d sec|"
			"|"
			"Default #Wildcard for directory windows : %s|"
			"Command #Interpreter path (COMSPEC)     : %s|"
			"DOS XPLORER #Home directory:            : %s|"
			"|"
			"Enable HP100/200LX #Zoom mode           : %s|"
			"Enable #CGA snow checking               : %s|"
			"|"
			"EXE #Swapping enabled                   : %s|"
			"#Path for swap file:                    : %s",
			C_msg_time,
			C_wildcard,
			(C_comspec==NULL)? "DEFAULT": C_comspec,
			C_home,
			yesno(C_zoom_mode),
			yesno(C_check_snow),
			yesno(C_swap),
			(C_swap_path == NULL)? "NONE": C_swap_path);
		slc = setupmenu(2, dflt, buf);
		switch (slc) {
			case 0:		setvalue("Error Message Timeout",
					0, 30, &C_msg_time); break;
			case 1:		break;
			case 2:		setstring("Default Wildcard",
					&C_wildcard, NAMELEN); break;
			case 3:		setstr2("Default Command Interpreter",
					&C_comspec, PATHL, h_comspec,
					&Ovr_comspec); break;
			case 4:		setstr2("Default Home Directory",
					&C_home, PATHL, h_home, &Ovr_home);
					break;
			case 5:		break;
			case 6:		C_zoom_mode = !C_zoom_mode;
					conf_vio();
					break;
			case 7:		C_check_snow = !C_check_snow;
					conf_vio();
					break;
			case 8:		break;
			case 9:		C_swap = !C_swap; break;
			case 10:	setstring("The directory swap"
					" files will be created in",
					&C_swap_path, PATHL); break;
			default:	return;
		}
		dflt = slc;
	}
}


struct FUNC {
	char	*name, *desc;
} Fnlist[] = {
	{	"CHDRV",	"Change Drive"			},
	{	"CHMOD",	"Change file attributes"	},
	{	"CLEAR",	"Clear screen"			},
	{	"COPY",		"Copy selected/tagged file(s)"	},
	{	"DELETE",	"Delete selected/tagged file(s)"},
	{	"EDIT",		"Edit file"			},
	{	"EXEC",		"Execute program"		},
	{	"GOTO",		"Goto file name"		},
	{	"HELP",		"View help pages"		},
	{	"HIDE",		"Hide directory window"		},
	{	"INFO",		"Display tag info"		},
	{	"MKDIR",	"Make directory"		},
	{	"MOVE",		"Move selected/tagged file(s)"	},
	{	"QCD",		"Launch QuickCD"		},
	{	"QFF",		"Launch QuickFF"		},
	{	"RMTREE",	"Remove directory tree"		},
	{	"SORTFILES",	"Sort files in dir window"	},
	{	"TAG",		"Tag files"			},
	{	"UNTAG",	"Untag files"			},
	{	"VIEW",		"View file"			},
	{	"WINMOVE",	"Move the directory window"	},
	{	"WINSIZE",	"Resize the directory window"	},
	{	NULL,		NULL				}
};

char *View_actions[] = {
	".ASCII",
	".DUMP",
	".HEX",
	".ROFF",
	".SCR"
};

void bind_fkeys() {
	int	dflt = 0, k, i, action, last, mode;
	char	*p;
	static char	buf[1024], b2[128];

	*buf = 0;
	for (i=0; Fnlist[i].name; i++) {
		sprintf(b2, "#%c - ", i+'A');
		strcat(buf, b2);
		strcat(buf, Fnlist[i].desc);
		strcat(buf, "|");
	}
	sprintf(b2, "#%c - ", i+'A');
	strcat(buf, b2);
	strcat(buf, "Nothing");
	last = i;

	for (;;) {
		k = setupmenu(2, dflt,
		" F-#1| F-#2| F-#3| F-#4| F-#5| F-#6| F-#7| F-#8| F-#9|"
		" F-1#0 ");
		if (k<0) return;
		dflt = k;

		if (F_keys[k] == NULL) {
			action = last;
		}
		else {
			strncpy(b2, F_keys[k], 128);
			b2[127] = 0;
			if ((p = strchr(b2, '.')) != NULL) *p = 0;
			if ((p = strchr(b2, ' ')) != NULL) *p = 0;
			for (i=0; Fnlist[i].name; i++) {
				if (!strnicmp(b2+1, Fnlist[i].name,
				strlen(Fnlist[i].name))) {
					action = i; break;
				}
			}
		}

		action = vio_menu(40, 0, 0x70, 0x0e, 0x0e, action, buf);
		if (action < 0) continue;

		sprintf(b2, "@%s", Fnlist[action].name);
		if (!strcmp(b2, "@VIEW")) {
			mode = vio_menu(40, 1, 0x70, 0x0e, 0x0e, 0,
				"Defaul#t|#ASCII mode|#Dump mode|#Hex mode|"
				"#ROFF mode|#Forth mode");
			if (mode > 0) {
				strcat(b2, View_actions[mode-1]);
			}
		}
		if (!strncmp(b2, "@VIEW", 5) ||
		!strcmp(b2, "@EDIT") ||
		!strcmp(b2, "@EXEC")) {
			strcat(b2, " %s");
		}
		F_keys[k] = xsave(b2);
	}
}


void actions() {
	static char	buf[81], pat[16], action[129];
	int	top, curr, last;
	int	i, j, k, red = 1;

	vio_color(0x07); vio_clear();
	vio_color(0x0e);
	vio_win(10, 2, 69, 17);
	curr = top = 0;

	vio_color(0x07);
	vio_move(10, 19); vio_puts("Arrow keys, PGUP, PGDN, HOME, END"
	"  move the bar");
	vio_move(10, 20); vio_puts("INS = Insert new action      DEL = "
	"Delete current pattern");
	vio_move(10, 21); vio_puts("ENTER = Edit current action  ESC = "
	"Back to menu");

	for (last = 0; Actions[last].pattern; last++)
		;

	for (;;) {
		if (red) {
			vio_color(0x07);
			for (i=0; i<14 && i+top < last; i++) {
				vio_move(12, 3+i);
				sprintf(buf, "%-12s : %-41.41s",
				Actions[i+top].pattern, Actions[i+top].action);
				vio_puts(buf);
			}
			while (i<14) {
				vio_move(11, 3+i++);
				for (j=0; j<56; j++) vio_putc(' ');
			}
			red = 0;
		}

		if (last) {
			sprintf(buf, "%-12s : %-41.41s", Actions[curr].pattern,
			Actions[curr].action);
		}

		vio_move(12, 3+curr-top); vio_color(0x70);
		vio_puts(last? buf: ">>> Press INS to insert new actions <<<");
		k = key();
		vio_move(12, 3+curr-top); vio_color(0x07);
		vio_puts(last? buf: "");

		switch (k) {
			case K_ESC:
				vio_clear(); return;

			case K_DOWN:
				if (curr >= last-1) break;
				if (++curr >= top+14) {
					++top; red = 1;
				}
				break;

			case K_UP:
				if (!curr) break;
				if (--curr < top) {
					--top; red = 1;
				}
				break;

			case K_PGDN:
				if ((curr += 12) >= last) curr = last-1;
				if ((top += 12) >= last) {
					if ((top = curr-12) < 0) top = 0;
				}
				red = 1;
				break;
			
			case K_PGUP:
				if ((curr -= 12) < 0) curr = 0;
				if ((top -= 12) < 0) top = 0;
				red = 1;
				break;

			case K_HOME:
				curr = top = 0; red = 1; break;

			case K_END:
				curr = last-1;
				if ((top = curr-12) < 0) top = 0;
				red = 1;
				break;

			case K_DEL:
				if (!last) break;
				sprintf(buf, "#Delete pattern \"%s\"|"
				"#Keep that pattern",
				Actions[curr].pattern);
				if (setupmenu(1, 0, buf) != 0) break;
				xfree(Actions[curr].pattern);
				xfree(Actions[curr].action);
				for (i=curr; i<last; i++) {
					Actions[i].pattern =
					Actions[i+1].pattern;
					Actions[i].action =
					Actions[i+1].action;
				}
				if (--last <= curr && curr) {
					if (--curr < top) --top;
				}
				red = 1;
				break;

			case K_INS:
				if (last >= MAX_ACTIONS-1) {
					vio_color(0x0e);
					vio_alert(-1, -1,
					"Too many actions", 12);
					break;
				}
				*pat = 0;
				if (vio_prompt(-1, -1, -1, 0x70, 0x0e, 0x70,
				12, pat, "Pattern") < 0) break;
				for (i=0; i<last; i++) {
					if (!strcmp(Actions[i].pattern, pat)) {
						vio_color(0x0e);
						vio_alert(-1, -1,
						"Pattern already exists", 12);
						break;
					}
				}
				if (i < last) {
					curr = i;
					if ((top = i-6) < 0) top = 0;
					red = 1;
					break;
				}
				*action = 0;
				sprintf(buf, "Action for \"%s\"", pat);
				if (vio_prompt(0, -1, vio_clipx-2, 0x70,
				0x0e, 0x70, 128, action, buf) < 0) break;
				for (i=last+1; i>curr; --i) {
					Actions[i].pattern =
					Actions[i-1].pattern;
					Actions[i].action =
					Actions[i-1].action;
				}
				Actions[curr].pattern = xsave(pat);
				Actions[curr].action = xsave(action);
				++last; red = 1;
				break;
		
			case K_CR:
				if (!last) break;
				sprintf(buf, "Edit action for \"%s\"",
				Actions[curr].pattern);
				strcpy(action, Actions[curr].action);
				if (vio_prompt(0, -1, vio_clipx-2, 0x70, 0x0e,
				0x70, 128, action, buf) < 0) break;
				if (!strcmp(Actions[curr].action, action))
					break;
				xfree(Actions[curr].action);
				Actions[curr].action = xsave(action);
				break;
		}
	}
}


void setup() {
	int	dflt = 0, slc;

	for (;;) {
		vio_color(C_dos_color);
		vio_clear();
		slc = setupmenu(1, dflt,
			"#General options|"
			"#Advanced options|"
			"#Color setup|"
			"#Predefined Colorsets|"
			"#Window setup|"
			"#Function key bindings|"
			"#Default actions|"
			"#Editor setup|"
			"#Quit");
		switch(slc) {
			case -1:	slc = 8; break;
			case 0:		general_opts(); break;
			case 1:		advanced_opts(); break;
			case 2:		col_setup(); break;
			case 3:		slc_colorset(); break;
			case 4:		win_setup(); break;
			case 5:		bind_fkeys(); break;
			case 6:		actions(); break;
			case 7:		setstring(
					"Path of the default editor:",
					&C_editor, PATHL); break;
			case 8:		switch (setupmenu(2, 0, "#Save & Exit|"
					"#Throw away changes|"
					"#Continue Setup")) {
						case 0:	if (!saveconf()) return;
						case 1:	return;
						case 2:	break;
					}
					break;
			default:	slc = dflt;
		}
		dflt = slc;
	}
}


void header() {
	int	x, y, x2, y2, tx, ty, c;
	int	explorer_c, five_o_c, back_c, text_c;

	explorer_c	= 0x1e;
	five_o_c	= 0x13;
	back_c		= 0x11;
	text_c		= 0x1b;

	if (vio_mono()) {
		explorer_c	= 0x0f;
		five_o_c	= 0x07;
		back_c		= 0x00;
		text_c		= 0x07;
	}

	delay(0);
	for (y=0; y<25; y++) {
		for (x=0; x<80; x++) {
			ndxx[y][x] = x;
			ndxy[y][x] = y;
		}
	}
	for (y=0; y<25; y++) {
		for (x=0; x<80; x++) {
			x2 = random(80);
			y2 = random(25);
			tx = ndxx[y2][x2];
			ty = ndxy[y2][x2];
			ndxx[y2][x2] = ndxx[y][x];
			ndxy[y2][x2] = ndxy[y][x];
			ndxx[y][x] = tx;
			ndxy[y][x] = ty;
		}
	}
	for (x=0; x<80; x++) {
		for (y=0; y<25; y++) {
			c = Title[ndxy[y][x]][ndxx[y][x]] & 0xff;
			vio_move(ndxx[y][x], ndxy[y][x]);
			switch (c) {
				case '' & 0xff:
					vio_color(five_o_c); break;
				case ' ':
					vio_color(back_c); break;
				default:
					if (c > 128)
						vio_color(explorer_c);
					else
						vio_color(text_c);
			}
			vio_putc(c);
			delay(2);
		}
	}
	timed_key(60);
}


int main(int argc, char **argv) {
	extern int	fuckup();
	char	*p;
	struct viobuf	*scr;

	hplx_zoom(0);
	if ((p = strrchr(argv[0], '\\')) != NULL) *p = 0;
	vio_init();
	scr = vio_protect(0, 0, 79, 24);
	puts(
"---  DOS XPLORER SETUP  Version 5.0A  Copyright (C) 1989-1999 Nils M Holm  ---"
	);
	harderr(fuckup);
	if (configure(argv[0]) || argc < 2 || strcmp(argv[1], "--quickstartup"))
		header();
	setup();
	vio_hide(scr);
	return(0);
}
